// rev 28-07-2023  delay mesure 10 -> 100mS !
// rev 07-05-2023  simplification !
// rev 01-05-2023
// rajout mesures en integer 
// rev 13/04/2023


#include <xc.h>
#include <pic18f27k42.h>          // pour  __delay..
#include "DS18B20_2024-07.h"
#include "OneWire_2023.h"

#define AVEC_TEMPO
extern void PrintChar(unsigned char txData);
uint16_t Lx;
unsigned char scratchPad[9] = {0,0,0,0,0,0,0,0,0};

void broadcastConvert_X() 
{
  //broadcast that temp conversions should begin, all at once so saves time
  onewireInit_X();
  onewireWriteByte_X(0xCC);
  onewireWriteByte_X(0x44);
  while (1) {
    if (onewireReadBit_X())  // au moins 1 capteur connect
      break;
  }
}


/*
float getTemperatureX(unsigned char* address)
{
  //get temperature from the device with address address
  unsigned char i;
  float temperature;
  unsigned char scratchPad[9] ; //= {0,0,0,0,0,0,0,0,0};
  for (i=0;i<9;i++) scratchPad[i] =0;
  onewireInit_X();
  onewireWriteByte_X(0x55);
  for (i = 0; i < 8; i++)  onewireWriteByte_X(address[i]);
  onewireWriteByte_X(0xBE);
  for (i = 0; i < 2; i++)  scratchPad[i] = onewireReadByte_X();
  onewireInit_X();
 Lx=scratchPad[1] <<8 + scratchPad[0];
 temperature=(float) Lx *0.062500; //Resolution   ;
  return temperature;
}
*/

float getTemperature1()
{
  unsigned char i;
  float temperature0;
  onewireInit_0();
  onewireWriteByte_0(0xCC);
  onewireWriteByte_0(0x44);
  __delay_ms(100);   // was 10
  onewireInit_0();
  onewireWriteByte_0(0xCC);
  onewireWriteByte_0(0xBE);
  for (i = 0; i < 2; i++)  scratchPad[i] = onewireReadByte_0();
  onewireInit_0();
  Lx=(scratchPad[1] <<8 )+ scratchPad[0];
  temperature0= (float)Lx * 0.06250 ; //Resolution   ;
  return temperature0;
}



float getTemperature2()
{
  unsigned char i;
  float temperature1;
  onewireInit_1();
  onewireWriteByte_1(0xCC);
  onewireWriteByte_1(0x44);
  __delay_ms(100);
  onewireInit_1();
  onewireWriteByte_1(0xCC);
  onewireWriteByte_1(0xBE);
  for (i = 0; i < 2; i++)  scratchPad[i] = onewireReadByte_1();
  onewireInit_1();
  Lx=(scratchPad[1] <<8 )+ scratchPad[0];
  temperature1=0.06250 * (float) Lx; //Resolution   ;
  return temperature1;
}

  
    

float getTemperature3()
{
unsigned char i;
  float temperature3;
  onewireInit_2();
  onewireWriteByte_2(0xCC);
  onewireWriteByte_2(0x44);
#ifdef AVEC_TEMPO
  // __delay_us(485);
    __delay_ms(100);
  #else
  //  350mS  en 11 b   700mS en 12b avec le test bit ci dessous
  while (1) {
  if (onewireReadBit_2())  // au moins 1 capteur connect
     break;
 }
#endif
  onewireInit_2();
  onewireWriteByte_2(0xCC);
  onewireWriteByte_2(0xBE);
  for (i = 0; i < 2; i++)  scratchPad[i] = onewireReadByte_2();
  Lx=(scratchPad[1] <<8 )+ scratchPad[0];
  temperature3= (float)Lx * 0.06250 ; //Resolution   ;
  return temperature3;
}
  
/*
int getTemperatureInt0(void) {
  //get temperature from the device with address address
  unsigned char i;
  int temperature0;
  unsigned char scratchPad[9] = {0,0,0,0,0,0,0,0,0};
  onewireInit_0();
  onewireWriteByte_0(0xCC);
  onewireWriteByte_0(0x44);
  while (1) {
  if (onewireReadBit_0())  // au moins 1 capteur connect
     break;
 }
 // __delay_ms(10);
  onewireInit_0();
  onewireWriteByte_0(0xCC);
  onewireWriteByte_0(0xBE);
  for (i = 0; i < 2; i++)  scratchPad[i] = onewireReadByte_0();
  temperature0 = ( (scratchPad[1] *256) + scratchPad[0])  ;
  onewireInit_0();
  return temperature0;
}


int getTemperatureInt1(void) 
{
  //get temperature from the device with address address
  unsigned char i;
  int temperature1;
  unsigned char scratchPad[9] = {0,0,0,0,0,0,0,0,0};
  onewireInit_1();
  onewireWriteByte_1(0xCC);
  onewireWriteByte_1(0x44);
 // __delay_ms(10);
   while (1) {
  if (onewireReadBit_1())  // au moins 1 capteur connect
     break;
 }
  onewireInit_1();
  onewireWriteByte_1(0xCC);
  onewireWriteByte_1(0xBE);
  for (i = 0; i < 2; i++)  scratchPad[i] = onewireReadByte_1();
  temperature1 =( ( scratchPad[1] *256) + scratchPad[0]) ;
  onewireInit_1();
  return temperature1;
}


int getTemperatureInt2(void)
{
  //get temperature from the device with address address
  unsigned char i;
  int temperature2;
  unsigned char scratchPad[9] = {0,0,0,0,0,0,0,0,0};
  onewireInit_2();
  onewireWriteByte_2(0xCC);
  onewireWriteByte_2(0x44);
  //__delay_ms(10);
   while (1) {
  if (onewireReadBit_2())  // au moins 1 capteur connect
     break;
 }
  onewireInit_2();
  onewireWriteByte_2(0xCC);
  onewireWriteByte_2(0xBE);
  for (i = 0; i < 2; i++)  scratchPad[i] = onewireReadByte_2();
  temperature2 = ( ( scratchPad[1] <<8) + scratchPad[0] ) ;
  onewireInit_2();
 //  sprintf(CRam1," scatchpad 0x%02X  0x%
  return temperature2;
}


 void Relecture_ID_datas(char *Po)
 {int i;
 CPrint(" OWS ID = ");  
   PrintChar('{');
   for (i = 0; i<8; i++)
  {
    sprintf(CRam1,"0x%02X",Po+i);
    Print(CRam1);
    if(i<7)PrintChar(',');
  }
  PrintChar('}');
  CRLF1();
 }



//  Recupere l'adresse et le CRC16 du capteur , et l'affiche sur terminal UART

void printSingleAddress_X()
{
  unsigned char i;
  unsigned char crc;
  onewireInit_X();
  //attach one sensor to port 25 and this will print out it's address
  onewireWriteByte_X(0x33);
  for (i = 0; i<8; i++) OWS_address[i] = onewireReadByte_X(); 
  if (OWS_address[0]==0x28)  CPrint(" Code Famille : DS18B20\r\n");
  
  CPrint(" OWS IDx = "); 
   PrintChar('{');
   for (i = 0; i<8; i++)
  {
    sprintf(CRam1,"0x%02X",OWS_address[i]);
    Print(CRam1);
    if(i<7)PrintChar(',');
  }
  PrintChar('}');
  CRLF1();
  //check crc
  crc = onewireCRC(OWS_address, 7);
  sprintf(CRam1," CRC = %02X \r\n",crc);
  Print(CRam1);CRLF1();  
}


void Change_Resolution_Sensor0( unsigned char Res)
{
   onewireInit_0();
   onewireWriteByte_0(0xCC);
   onewireWriteByte_0(0x4E);
   onewireWriteByte_0(0x00);
   onewireWriteByte_0(0x00);
   onewireWriteByte_0(Res);
    onewireInit_0();
}   
   

void Change_Resolution_Sensor1( unsigned char Res)
{
   onewireInit_1();
   onewireWriteByte_1(0xCC);
   onewireWriteByte_1(0x4E);
   onewireWriteByte_1(0x00);
   onewireWriteByte_1(0x00);
   onewireWriteByte_1(Res);
    onewireInit_1();
} 

void Change_Resolution_Sensor2 (unsigned char Res)
{
   onewireInit_2();
   onewireWriteByte_2(0xCC);
   onewireWriteByte_2(0x4E);
   onewireWriteByte_2(0x00);
   onewireWriteByte_2(0x00);
   onewireWriteByte_2(Res);
    onewireInit_2();
}   

 */    