
// rev 15/09  augment delai eeprom  
// rev 07-09-2023
#include "builtins.h"    
#include "UART1_Functions.h"
#include "Define_Org.h"
#include "Eeprom_PIC_2024.h"
#include <stdio.h>

//extern  unsigned char Eeprom_Donnees[][17];
//extern  Adresses des 3 capteurs de temprature */
//extern unsigned char  SENSOR_ADDRESS[3][8  // utilis si 1 seul bus OWS !

extern  unsigned char Flag_Eeprom;
//extern unsigned char CRam1[];
extern char CRam1[];
extern float Txcor[] ;
extern  uint8_t Bavard;

#ifndef _XTAL_FREQ
#define _XTAL_FREQ 64000000 
#endif


void DATAEE_WriteInt(uint16_t iAdd, unsigned int iData)
{ unsigned char Ce;
  Ce=(iData>>8);
  DATAEE_WriteByte(iAdd, Ce);
  Ce=(iData & 0x00FF);
  DATAEE_WriteByte(iAdd+1, Ce);     
}    


void DATAEE_WriteByte(uint16_t bAdd, unsigned char bData)
{
    unsigned char GIEBitValue = INTCON0bits.GIE;
    NVMADRH = (unsigned char)((bAdd >> 8) & 0x0003);
    NVMADRL = (unsigned char)(bAdd & 0x00FF);
    NVMDAT = bData;
    NVMCON1bits.NVMREG = 0;
    NVMCON1bits.WREN = 1;
    INTCON0bits.GIE = 0;     // Disable interrupts
    NVMCON2 = 0x55;
    NVMCON2 = 0xAA;
    NVMCON1bits.WR = 1;
     __asm("NOP");
    // Wait for write to complete
    while (NVMCON1bits.WR)
    {
         __asm("NOP");
    }
    NVMCON1bits.WREN = 0;
    INTCON0bits.GIE = GIEBitValue;   // restore interrupt enable
    __delay_ms(25);
}

uint8_t DATAEE_ReadByte( uint16_t bAdd)
{   uint8_t valeur;
    NVMADRH = (unsigned char)((bAdd >> 8) & 0x0003);
    NVMADRL = (unsigned char)(bAdd & 0x00FF);
    NVMCON1bits.NVMREG = 0;
    NVMCON1bits.RD = 1;
    __asm("NOP");  // NOPs may be required for latency at high frequencies
    __asm("NOP");
    __asm("NOP");
    __asm("NOP");
    valeur=NVMDAT;
    __delay_ms(25);
    if (Bavard==22)
    {  sprintf(CRam1,"at 0x%4X ->  %d  0x%02X\r\n",bAdd,valeur,valeur);
       Print(CRam1);
    }
    return (valeur);
}

 float  Read_Float_from_Eeprom(uint16_t Adresse) 
   { 
     uint16_t j; 
     unsigned char *Pt;
     float Rf=0.00;  
     Pt=&Rf;
     *(Pt)=DATAEE_ReadByte(Adresse); 
     *(Pt+1)=DATAEE_ReadByte(Adresse+1);
     *(Pt+2)=DATAEE_ReadByte(Adresse+2);
     *(Pt+3)=DATAEE_ReadByte(Adresse+3);
     if(Bavard == 20 )
     {    
     sprintf(CRam1," at 0x%4X ->  %3.2f\r\n",Adresse,Rf);
     Print(CRam1);
     }
     return Rf;
   }  
 
  
void Sauve_Float_To_Eeprom(uint16_t ad1,float Fv)
{  uint16_t i;
   static unsigned char *pt;
    GIEH=0;
   // sprintf(CRam1," Sauve %5.2f value at adr=%04x\r\n",Fv,ad1);
  //  Print(CRam1);
    pt=&Fv;
   for (i=0;i<4;i++)
    {  
     // PrintChar(i+48);PrintChar(' ');
	  DATAEE_WriteByte(ad1+i,*(pt+i));
    }
     GIEH=1;
}   

/*
void Lecture_Eeprom_Parametres(char Visu)
{ int j,k;
    CPrint(" Relecture Parametres datas eeprom : \r\n");
    for (j=0;j<80;j=j+4)
    { 
       k=Org_Sauve_Param_Travail+j;
      F0= Read_Float_from_Eeprom(k);
      if (Visu==1)
        {
           sprintf(CRam1," %04X  %5.2f %c ",k,F0,9);
           Print(CRam1);
           CRLF1();
          }
    }
 }
  */

void Lecture_Eeprom_Table_Programmes_Horaires(char Visu)
{ // Lecture et Visu seulement !
    static uint8_t cx;
    static uint16_t i,j,k;
    i=0; j=0;k=0;
    cx= DATAEE_ReadByte(0);
    Flag_Eeprom= cx;
    //__delay_ms(25);
    if (Visu==1)
     {
        CPrint(" Relecture datas eeprom : \r\n");
        CPrint(" Flag Run Once at @ 0x0000 =");
        PrintChar(cx/10+48);  PrintChar(cx%10+48); CRLF1();
        CPrint(" Programme version : ");
        CRam1[0]=DATAEE_ReadByte(1); CRam1[1]=DATAEE_ReadByte(2);
        CRam1[2]=DATAEE_ReadByte(3); CRam1[3]=DATAEE_ReadByte(4);
        CRam1[4]=DATAEE_ReadByte(5); CRam1[5]=DATAEE_ReadByte(6);
        CRam1[6]=0; Print(CRam1);CRLF1();
     }
    // parcours des 10 tables programmation horaires
    for (j=0;j<10;j++)
    {
      k=(j*32)+Org_Sauve_Progr_Travail ;  
      if (Visu==1)  // imprime NOM du programme sur 7 car
       { 
            sprintf(CRam1," 0x%04X  Nom : ",k);
            Print(CRam1);
            for (i=24;i<31;i++)
            {  cx= DATAEE_ReadByte(k+i); 
            //__delay_ms(25);
                PrintChar(cx);          
            }
         CRLF1(); 
       }
     //------------------MATIN ---------
      for (i=0;i<12;i++)
      {    
          cx= DATAEE_ReadByte(k+i); 
          //__delay_ms(25);
          if (Visu==1)
          {
            sprintf(CRam1," 0x%02X,  ",cx);
            Print(CRam1); 
          }
       } 
       if (Visu==1) CRLF1();
        //---------------- APRES MIDI ---------
       for (i=0;i<12;i++)
       {    
          cx= DATAEE_ReadByte(12+k+i);
          //__delay_ms(25);
          if (Visu==1)
          {
            sprintf(CRam1," 0x%02X,  ",cx);
            Print(CRam1); 
          }
       } 
       if (Visu==1) CRLF1();
     }
  }

  void Restitue_Corrections_Temper(void)
      {         
      Txcor[0]= Read_Float_from_Eeprom(Org_Txcor);
      Txcor[1]= Read_Float_from_Eeprom(Org_Txcor+4);
      Txcor[2]= Read_Float_from_Eeprom(Org_Txcor+8);
      }
    
    void Sauve_Corrections_Temper(void)
    {
       Sauve_Float_To_Eeprom(Org_Txcor,Txcor[0]);
       Sauve_Float_To_Eeprom(Org_Txcor+4,Txcor[1]);
       Sauve_Float_To_Eeprom(Org_Txcor+8,Txcor[2]);    
    }   
 
    
/*
//void Sauve_ID_sondes_en_Eeprom(unsigned char *ici)  
void Sauve_Parametres_en_Eeprom()  
{    static unsigned char cc;
    static int i,j,k;
    i=0; j=0; k=0;
    GIEH=0;
    //Flag_Eeprom=99;
    CPrint("\r\n Sauve ID# sondes DS18B20 \r\n");
    CPrint(" Flag Eeprom @0x0000 = ");
    DATAEE_WriteByte(0,Flag_Eeprom); __delay_ms(25);
    PrintChar((Flag_Eeprom/10) +48);    PrintChar((Flag_Eeprom%10) +48);CRLF1();
  
    for (i=0;i<3;i++)
      {  CPrint(" Sonde ID#");PrintChar(i+48); 
         k=(i*16)+ 0x03A0;
         sprintf(CRam1,"@ 0x%04X  -> ",k);
         Print(CRam1); 
         for (j=0;j<8;j++)
         {
          // cc=*(ici+k+j);  
          cc= SENSOR_ADDRESS[i][j];  
          DATAEE_WriteByte(k+j,cc); __delay_ms(25);
          sprintf(CRam1,"0x%02X,",cc);	// en ascii	   
          Print(CRam1);
          
         }
         CRLF1();
       }
     CRLF1();
     GIEH=1;

 }

unsigned char  Restitue_Parametres_en_Eeprom(int Element)
{   // Eeeprom -> Tables de Travail
   static int i,j,k;
   static unsigned char cx;
   j=0;i=0;k=0;
      CPrint(" Read flag @0x00 = ");
      Flag_Eeprom=DATAEE_ReadByte(0);__delay_ms(50);
      sprintf(CRam1,"0x%02X", Flag_Eeprom);
      Print(CRam1);
    // utoa(CRam1, Flag_Eeprom,10);
   //   My_Print(CRam1);CRLF1();
     CPrint(" Restitue sonde ID#");
     PrintChar(Element+48);CRLF1();
     if ( (Element>3) || (Element<1))  return 0; 
     k= (Element<<4) + 0x0010; // Element*16 +10
     sprintf(CRam1,"@ 0x%04X ", k);
     Print(CRam1);
     for (j=0;j<8;j++)
     {
        cx= DATAEE_ReadByte(k+j); __delay_ms(25);
       SENSOR_ADDRESS[Element-1][j]=cx;
       sprintf(CRam1,"0x%02X,",cx);
       Print(CRam1);
      }
      SENSOR_ADDRESS[Element-1][j]=0;  //string terminator
      CRLF1();
     //last check :
      Print((char *)&SENSOR_ADDRESS[Element-1][0]);
      CRLF1();
 }
  
 */