
#include "xc.h"
#include <builtins.h>
#include <string.h>
#include "LCD_4bits_I2C_2024-01.h"

//rev 26-10-2023  diminu delais dans void LCD_Chr_At(int Ligne,int col,char c1)
// + modif && par & sur le test sortie si  byte= 0
// rev 10/08/2023  1 seul jeu de car speciaux
// rev  05/07/2023   Rajout set2 et set3   jeux de caractere speciaux utilis!

#ifndef _XTAL_FREQ 
  #define _XTAL_FREQ 64000000
#endif

void Erase_Line(int L)
{
switch(L)
 {
 case 1:
  {
   LCD_Cmd(LCD_LINE1);    
    LCD_putsRom(Efface);      
   LCD_Cmd(LCD_LINE1);          
   break;
  }
  case 2:
  {
   LCD_Cmd(LCD_LINE2); 
   LCD_putsRom(Efface);     
   LCD_Cmd(LCD_LINE2);
    break;
  } 
  case 3:
  {
   LCD_Cmd(LCD_LINE3); 
     LCD_putsRom(Efface);  
   LCD_Cmd(LCD_LINE3);
   break;                     // 25-10-2023
  } 
  case 4:
  {
   LCD_Cmd(LCD_LINE4);    
     LCD_putsRom(Efface);     
   LCD_Cmd(LCD_LINE4);
    break;
  } 
 }
 __delay_ms(100);
}

 //  LCD 2x16 + PCF8753
 // PCA8574 I2C LCD Routine
 // LCD Data PCA8574: P0,P1,P2,P3     Poids faibles !
 // LCD Control: P7: Back Light not used fixé avec R pull up., P4=E-Enable, P5=not Used RW au Grnd , P6= RS


//void LCD_putcmd(unsigned char d,unsigned char cmdtype)
void LCD_putcmd( char d, char cmdtype)
{
  unsigned char lcddata;
 // avec RS=0
    // Put the Upper 4 bits data  on P7..P4
  lcddata =  (d & 0xF0) | LCD_EN | LCD_BL ;
   I2C_PCF8574_Write(Addr,lcddata );
  Delay_10us();
  // Write Enable Pulse E: Hi -> Lo
   lcddata =  (d & 0xF0)| LCD_BL  ;
   I2C_PCF8574_Write(Addr,lcddata);
  Delay_10us();      // __delay 1us for 16 MHz Internal Clock
  // cmdtype = 0; One cycle write, cmdtype = 1; Two cycle writes
  if (cmdtype==1)
  {
    // Put the Lower 4 bits data   on P7 ..P4
    lcddata = ((d & 0x0F) <<4) | LCD_EN | LCD_BL ;
     I2C_PCF8574_Write(Addr,lcddata);
    Delay_10us();    // __delay 2us for 16 MHz Internal Clock
    // Write Enable Pulse E: Hi -> Lo
     lcddata = ((d & 0x0F)<<4) | LCD_BL ;
     I2C_PCF8574_Write(Addr,lcddata);
    Delay_10us();    // __delay 1us for 16 MHz Internal Clock
  }
}

void Delay_10us()
{
 int i2;
 for (i2=0;i2<160;i2++)
 {
     __asm("NOP");
 }    
}    


//void LCD_putch(unsigned char d)
void LCD_putch( char d)
{
  unsigned char lcddata;
   // Put the Upper 4 bits data     on P0 ..P3
  // avec RS=1
  lcddata =( (d & 0xF0) >>4 )| LCD_RS;
  I2C_PCF8574_Write(Addr,lcddata | LCD_EN);
  Delay_10us();
  // Write Enable Pulse E: Hi -> Lo
  lcddata = (  ( (d & 0xF0) >>4 ) |  LCD_RS ) & (~LCD_EN) ;
  I2C_PCF8574_Write(Addr,lcddata);
   Delay_10us();
  // Put the Lower 4 bit data
  lcddata = (d & 0x0F) | LCD_RS | LCD_EN;
  I2C_PCF8574_Write(Addr,lcddata);
  Delay_10us();
  // Write Enable Pulse E: Hi -> Lo
  lcddata = ( (d & 0x0F) | LCD_RS ) & (~LCD_EN);
  I2C_PCF8574_Write(Addr,lcddata);
  Delay_10us();
  //__delay_us(10);      // __delay 1us for 16 MHz Internal Clock
}


void LCD_Cmd(unsigned char d)
{
  unsigned char LcdCde;
 // avec RS=0
    // Put the Upper 4 bits data  on P7..P4
    LcdCde =   (d & 0xF0)  | LCD_EN | LCD_BL;
    I2C_PCF8574_Write(Addr,LcdCde );
    Delay_10us();
  // Write Enable Pulse E: Hi -> Lo
  // LcdCde =  ( (d & 0xF0) >> 4  | LCD_RW  )  & (~ LCD_EN);
     LcdCde =   (d & 0xF0) | LCD_BL ;
     I2C_PCF8574_Write(Addr,LcdCde);
    Delay_10us();      // __delay 1us for 16 MHz Internal Clock
  // Put the Lower 4 bits data   on P7....P4
     LcdCde = ((d & 0x0F)<<4)| LCD_EN | LCD_BL;
     I2C_PCF8574_Write(Addr,LcdCde);
      Delay_10us();    // __delay 2us for 16 MHz Internal Clock
    // Write Enable Pulse E: Hi -> Lo
     LcdCde = (d & 0x0F)<<4 | LCD_BL ;
     I2C_PCF8574_Write(Addr,LcdCde);
      Delay_10us();    // __delay 1us for 16 MHz Internal Clock
      if(d==1) __delay_ms(100);
}


void LCD_Data(unsigned char d)
{
  static  unsigned char lcddata;
   // Put the Upper 4 bits data     
  //on P3 ..P0 LCD2x16 et P7..p4 LCD4x20
  // avec RS=1
  lcddata=  ((d & 0xF0) )| LCD_RS | LCD_EN | LCD_BL;
  I2C_PCF8574_Write(Addr,lcddata);
    Delay_10us();      // __delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
 // lcddata =  ( ( (d & 0xF0) >>4 ) |  LCD_RS | LCD_RW  )  & (~LCD_EN);
  lcddata =   (d & 0xF0)  | LCD_RS | LCD_BL ;
  I2C_PCF8574_Write(Addr,lcddata);
   Delay_10us();      // __delay 1us for 16 MHz Internal Clock
  // Put the Lower 4 bit data
 // lcddata = (d & 0x0F) | LCD_RS | LCD_EN | LCD_RW;
  lcddata =  ( (d & 0x0F) <<4 ) | LCD_RS | LCD_EN | LCD_BL;
  I2C_PCF8574_Write(Addr,lcddata);
    Delay_10us();      // __delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
   lcddata =  ( (d & 0x0F) <<4 ) | LCD_RS | LCD_BL ;
  I2C_PCF8574_Write(Addr,lcddata);
    Delay_10us();     // __delay 1us for 16 MHz Internal Clock
}



void LCD_init(void)  // OK !
{
  
  // Wait for more than 15 ms after VCC rises to 4.5 V
  CPrint(" .1");
  LCD_putcmd(0x30,0);
  // Wait for more than 4.1 ms
  __delay_ms(5);
   PrintChar('2');
  // Send Command 0x30
  LCD_putcmd(0x30,0);
  __delay_ms(1);
  // Send Command 0x30
     PrintChar('3');
  LCD_putcmd(0x30,0);
    __delay_ms(1);
  // Function set: Set interface to be 4 bits long (only 1 cycle write).
      PrintChar('4');
 LCD_putcmd(0x25,0); 
    __delay_ms(1);
  // Function set: DL=0;Interface is 4 bits, N=1; 2 Lines, F=0; 5x8 dots font)
       PrintChar('5');
  LCD_putcmd(0x28,1);
     __delay_ms(1);
  // Display Off: D=0; Display off, C=0; Cursor Off, B=0; Blinking Off
       PrintChar('6');
  LCD_putcmd(0x08,1);
    __delay_ms(1);
  // Display Clear
       PrintChar('7');
  LCD_putcmd(LCD_CLEAR,1);
    __delay_ms(25);
  // Entry Mode Set: I/D=1; Increament, S=0; No shift
       PrintChar('8');
  LCD_putcmd(0x06,1);
      __delay_ms(1);
  // Display On, Cursor Off
       PrintChar('9');
  LCD_putcmd(0x0C,1);
    __delay_ms(1);
        PrintChar('A');
}



void LCD_putsRom(const  char *s1)
{  int i;
    i=0;
    while(  (*(s1+i)!=0) && (i<NbCarPL)  )
//  while((*s1 != 0) & (i<NbCarPL))
  {
    LCD_Data(*(s1+i)); 
    i++;
    Delay_10us(); // was __delay_ms(1);
  }
}

//void LCD_puts( unsigned char *s)
void LCD_puts( char *s)
{  int i;
   i=0;
 //sortie si caractere point null et i>20
  while((*(s+i) != 0) & (i<NbCarPL))
  {
    LCD_Data(*(s+i));  // LCD_putch(*(s+i));
    Delay_10us();
    i++;
  }
}
  

//void LCD_Write_CText(const unsigned char *tt)
void LCD_Write_CText(const char *tt)
{  static int i1;
   i1=0;
   while ((*tt) & (i1<NbCarPL))
   {
   i1++;
   LCD_Data(*(tt++));
     Delay_10us(); // was __delay_ms(1);
   };
 }


//void LCD_Chr_At(int Ligne,int col,unsigned char c1)
void LCD_Chr_At(int Ligne,int col,char c1)
{
  // Addr=LCD_ADDR;
  if (col==0) col=1;  
  if(col>NbCarPL) col=NbCarPL;
  if (Ligne==1) LCD_Cmd(LCD_LINE1+col-1);  
  if (Ligne==2) LCD_Cmd(LCD_LINE2+col-1); 
  if (Ligne==3) LCD_Cmd(LCD_LINE3+col-1);  
  if (Ligne==4) LCD_Cmd(LCD_LINE4+col-1); 
   __delay_ms(1);
    LCD_Data(c1); //  LCD_putch(c1);
    __delay_ms(1);// was __delay_ms(25);
 }


//void LCD_At(unsigned char Ligne,unsigned char col)
void LCD_At( char Ligne, char col)
{
  //Addr=LCD_ADDR;
  if (col==0) col=1;  
   if(col>NbCarPL) col=NbCarPL-1;
  if (Ligne==1) LCD_Cmd(LCD_LINE1+col-1);  
  if (Ligne==2) LCD_Cmd(LCD_LINE2+col-1); 
  if (Ligne==3) LCD_Cmd(LCD_LINE3+col-1);  
  if (Ligne==4) LCD_Cmd(LCD_LINE4+col-1); 
   __delay_ms(1);// was __delay_ms(20);
}

//void LCD_Write_Text_At(unsigned char Ligne,unsigned char Col,unsigned  char * t1)
void LCD_Write_Text_At( char Ligne, char Col,  char * t1)
{  LCD_At(Ligne,Col);
   LCD_puts(t1);
}

// 15-09-2023
//void LCD_Write_CText_At(unsigned char Ligne,unsigned char col, const unsigned char * t1)
void LCD_Write_CText_At( char Ligne,char col, const  char * t1)
{ LCD_At(Ligne,col);
  LCD_putsRom(t1);
}

//   affiche les pixels de chaque jeux de caracteres sur le terminal UART
void LCD_Load_Custom_Chars(int Cause)
// 1 seul jeu utilis!
{ 
 unsigned int  i, j;
 unsigned int  k;
 // Set address counter pointing to CGRAM address 0.
 LCD_Cmd(0x40);
  __delay_ms(25); // was 250
 // Load custom lcd character data into CGRAM.
 // It can only hold a maximum of 8 custom characters.
 k=0;
 if ( Cause==1) 
 {
     CPrint(Special_Name1[k]);
     CRLF1();
 }    
 for(i = 0; i <64; i++)
 {
   if (Cause==1)
   {
      if ( (i>0) && (  ( i%8) ==0)  )
      {
      CPrint(Special_Name1[k]); 
      k++;
      CRLF1();
     }
   } 
   LCD_Data(LCD_Custom_Chars_Set1[i]);
   if (Cause==1) 
   {  Decompile_byte( LCD_Custom_Chars_Set1[i]);
      //   __delay_ms(10);
      CRLF1();
   }
  } // for i 
 // Set address counter pointing back to the DDRAM.
 LCD_Cmd(0x80);
  __delay_ms(10); // was 150
}

