
#include <xc.h>
#include <math.h>
#include <stdint.h>
#include <ctype.h>
#include <stdbool.h>
#include <stdio.h>
#include <limits.h>
#include <string.h>

#ifndef _XTAL_FREQ
    #define _XTAL_FREQ 64000000 
#endif

#define Carte_PCB
// #define Prototype
#define EEPROM_24C32_ADDR  0xAE    // ou 0x57 si A0,A1,A2=1  

#ifdef Prototype
    #define LCD_ADDR 0x27  // PCF8574 inclus sur gros LCD 4x20 Bleu Paul sur Prtototype Breaboard
#endif
#ifdef Carte_PCB
#define LCD_ADDR 0x20   // PCF8574  externe LCD 4x20 Blanc
    // PCF8574 externe  pour LCD 2x16 avec A0,A1,A2  au niveau logique 0
#endif

// hardware
/*
   Pour les R srie des Leds au PIC, avec Vref maxi :
  RA3  L4 (Jne) :  R12 = 430      (5-2,1-0,2)/430 = 6.3mA
  RA4  L3 (Rge) :  R13 = 470      (5-1,8-0,2)/470 = 6,4mA
  RA5  L2 (Blu) :  R14 = 330      (5-2,8-0,2)/330 = 6,1mA
  RA6  L1 (Vrt) :  R15 = 360      (5-2,5-0,2)/360 = 6,4mA
  RA7  L6 (Rge)* : R30 = 470      (5-1 ,8-0,2)/470 = 6.4mA 
   si SW1 est un poussoir  led intgr (initialement R30 = 330W)
o  Pour la R srie  la RTC, avec Vref maxi, j?opte pour :
  SQW  L5 (Rge) : R27 = 1.5k      (5-1,8-0,2)/1500 = 2mA
 */

#ifndef Byte
#define Byte  uint8
#endif
#ifndef Word
#define Word  uint16_t
#endif

#define With_RTC_DS3231

#define VERSION "241004"
//  supprimer les 2 premiers lignes  706 707
//  init  Affectation_Hebdo[8]={5,4,3,6,6,5,2,0};
// donc supprim ligne 2288
// rajout du test de verif via YAT terminal
// rajout init corrections de temperatures  0.00 par defaut..sinon -nan
//#define VERSION "240924"
// usage de   Requete_Bruleur=1 au lieu de cde  Bruleur=1
// bug  ligne 947   Bruleur=ON; Cpt_Bruleur=0;  ' <----- bug oubli de RAZ compteur
//#define VERSION "240920"
// cloture developpement !
// pas de bug sur "Repas" (voir mail H.T.du 29/09))
//#define VERSION "240918"
// modif MENU SW4  Destination  ligne 467
// bug version program   was  Programme version : 094!!
//#define VERSION "240917"
// correctif bugs dans Menu 4
//#define VERSION "240916"
// modif alarme et hors gel
//#define VERSION "240914"
// correctif ligne 2911  choix hors gel en eeprom 70
//#define VERSION "240909"
// corrig erreur menu6,utilisait  Org_Sauve_Progr_Travail au lieu de Org_Sauve_Param_Travail
//#define VERSION "240908"
// imprime restitution eeprom
//#define VERSION "240905"
// se referer au  Schma V14.0.0_2023-0728.pdf
// remplacement du PIC18F27K42 pour PB entree RC5 crame
// Alarmes RC1 et RC2 sont references au VSS et non pas au VDD
// rajout #define Paul_Board
//#define VERSION "240904"
// big probleme hardware  SW6 ne reponds plus suite 
// erreur de branchement alim +9V sur borne #6 au lieu de #4
// port B HS ??   I2C OK UART OK
// modif clignotement leds
// #define VERSION "240903"
// rev H.T   // modif Dialogue_Operateur_PC_via_UART_2024-0904.inc"
// Scema_Chaudiere_V21.1.4.sch (kicad) du 01 09 2024
// test Timer2 100ms , Timer4 500ms et clignotement leds PortA 3  6 via cde YAT
// un peu de menage dans le main.c
// #define VERSION "240824"
// modif MENU1   Affichage repos LCD   Cligotant Led
// #define VERSION "240818"
// modif Dialogue_Operateur_PC_via_UART_2024-0812.inc"
// #define VERSION "240814"
// modif Affiche_LCD_Repos...
// inclusion Menu1 version HT
// #define VERSION "240812"
// rajout clignote 1Hz RA6 RA5
// #define VERSION "240811"
// new Menu direct SW1  
// #define VERSION "240810"
// #define TEST_ZONE_1     ..ok
// MENU DIRECTS SW1
// #define VERSION "240809"
// suite correctif H.T. sur menu SW4
// #define VERSION "240805"
// rajout restitue parametres from Eeprom
// #define VERSION "240803"
// activation sauvegarde en eeprom de l'Affectation_Hebdomadaire
// MAIS Problemo avec init en dur dans le code de la table Affectation_Hebdo
// voir problematique  https://www.fantaspic.fr/viewtopic.php?style=4&f=10&t=1308&start=10
// pre_chargement Eeprom PIC 18F27K42
// #define VERSION "2024-0802"
// reduction choix modif programme de 2  9 au lieu de 0  11
// correctif bug indice Programme dans SW4
// bug calcul destination eeprom
// rajout TMR6  xx fois 500mS et interrupt
// modif Menu 10.2
// #define VERSION "2024-0731"
// mis usage STM1 en Option , pas besoin de calucler en S, mS est suffisant
// modif Affiche_LCD_Repos_2024-0730.inc
// modif Dialogue_Operateur_PC_via_UART_2024-08.inc"
// #define VERSION "2024-0729"
// correctif bug void MAJ_RTC(void)  jS>7 ->jS>6
// #define VERSION "2024-0728"
// petite modif concernant les 3 sondes DS18B20
// double lecture des 3 capteurs ..
// because 85.00  la remise sous tension
// #define VERSION "2024-0725"
// rajout dossier  C:/Program Files/Microchip/MPLABX/v6.00/packs/Microchip/PIC18F-K_DFP/1.6.125
// au lieu de C:\Users\Paul\.mchp_packs\Microchip\PIC18F-K_DFP\1.6.125
// #define VERSION "2024-0714"
// remise en service Progr_En_Cours=Affectation_Hebdo[jS];
// #define VERSION "2024-0524"
// rajout info Demi_Heure_En_Cours
// #define VERSION "2024-0521"
// revu traitement menu direct 7 
// #define VERSION "2024-0516"
// XC8 linker memory model : modifie ,pass de 17FFF  0-1FFFF
//  Program space   used 1308Dh ( 77965) of 20000h bytes   ( 59.5%)
// recomplation --> 
// optimisation niveau 2 -> 
// Program space        used 1308Dh ( 77965) of 18000h bytes   ( 79.3%)
// debugging SW4 Menu
// #define VERSION "2024-0509"
// avec optimisation niveau 0 
// Program space        used 15DADh ( 89517) of 18000h bytes   ( 91.1%)
// SW4 eeprom storage
// #define VERSION "2024-0507"
// SW4 1ere partie
// #define VERSION "2024-0504"
// #define VERSION "2024-029"
// Menu SW4 ...1ere partie
// #define VERSION "2024-0417"
// Menu 10.X  ..ok
// #define VERSION "2024-0416"
//tests et correctifs Menu10.3 10.4
// #define VERSION "2024-0415"
// Menu10.4..OK
// #define VERSION "2024-0414"
// conditions pour clignote menu
// bug trouv ..SPas en local dans menu10.3 !!!
// #define VERSION "2024-0413"
// BLOCAGE programme sur  Test presence devices sur Bus I2C1 ????
// because ereur Rafraichit_Ligne_Menu_LCD(char Degr)
// #define VERSION "2024-0412"
// menus 10.3 et 10.4   bug !!!
// #define VERSION "2024-0411"
// modif const char Libelles_Menus_10[7] [13] =
// {"      "}, //efface plac en fin de table 12
// #define VERSION "2024-0411"
// correctuion bug  Menu10.2 .. et MENU10.1 !
// #define VERSION "2024-0410"
//voir MENU10_1234_2024-0410.inc   Menu10.1 
// #define VERSION "2024-0407"
// Chaudiere_New_Menu_CONSIGNES_10.1_2024-0407.drawio
// modif Min_INT_cor -20 -> =0 et MAX_Int_cor=+2.0
// #define VERSION "2024-0405"
// usage de variables Fm1.2.3. particulieres aux Menu10.x au lieu de F1 .2.3 communes
// #define VERSION "2024-0404"
// new  menu 10.2
// #define VERSION "2024-0402"
// new menu voir  Menu 10.x_SW0_2024-0401.xls
// #define VERSION "2024-0331"
// rev Menu 10.1 et 10.3
// #define VERSION "2024-0330"
// correctif menu 10.3 avec float SPas3 inutile car pas deja defini et fixe=5.0C
// Menu 10.7 sauveg eeprom
// menu 8 alarmes 
// #define VERSION "2024-0327"
// rajout Menu 10.7 indice NGR
// test progr Eau_cbl H.T.
// #define VERSION "2024-0326"
// Menu 4  decompos en 2 parties
// affectation programme du jour
// modif programme
// #define VERSION "2024-0324"
// #define TEST2 
// rajout affichage plages programmation
// #define VERSION "2024-0321"
// Test Zone 2   pour definition des plages 
// #define VERSION "2024-0309"
// rajout Menu MENU10_6_Hysteresis(void)
// #define VERSION "2024-0119"
// schema V14.0.0
// RC7 Alarm1 =1 pour normal
// CPrint(" Re-affectation RC5 (SW6 input) en Sortie pour Alarme L5 \r\n");
// TRISCbits.TRISC5=0;  // RC5 en sortie
// ODCONCbits.ODCC5=1;  // modif RC5 seulement, sans toucher RC4 et RC3 I2C
// LATCbits.LATC5=1 ;   // pas d'alarme 
// #define INIT_AUTO_RTC   <-- elimin 23/10/2023
// #define VERSION "2024-0119"
// #include "Chaudiere_XC8_Program_Historique_2024-01_2023-04.txt"

#define Paul_Board     // 17-09-2024

#define Test_Tables
//#define With_SMT1
#ifdef With_SMT1
    #define START_SMT1  SMT1_Measure=0; ST=&SMT1_Measure;SMT1STATbits.RST=1; SMT1CON1bits.SMT1GO=1;  
    #define STOP_SMT1  *(ST)=SMT1TMRL; *(ST+1)=SMT1TMRH;*(ST+2)=SMT1TMRU;*(ST+3)=0;
#endif

#define MCU " 18F27K42"
#define POWER_SUPPLY " 5V "
#define DIR " C:\\MPLABX_PrOJECTS"
#define COMPILO "XC8 V2.36 C99"
#define PACK "PIC18F-K_DFP 1.6.125"

#define CR 13
#define LF 10
#define TAB 9

#ifdef With_SQA_Analyser
    #define SQA_Dir TRISAbits.TRISA3
    #define SQA LATAbits.LA3
#endif

// #define HIVER '1'     // elimin 23/10
// #define ETE  '0'


#define ON  1
#define OFF 0

#define MARCHE 1
#define ARRET 0

// d'apres le dernier schema Chaudire_V20.1.0_2024-0219.pdf
#define LED_bleu    LATAbits.LA5    // ECO	
#define LED_Eco     LATAbits.LA5    // 23/08
#define LED_Conf    LATAbits.LA6    // 23/08
#define LED_vert    LATAbits.LA6    // Led vert : ECO (SW1   Eco)	
#define LED_jaune   LATAbits.LA3    // Led Jaune : CMP (Compensation TC Ressentie)	
#define LED_Comp    LATAbits.LA3
#define LED_rouge   LATAbits.LA4    // LED_rge	Led Rouge : PRG (Programmation)	
#define LED_Prg     LATAbits.LA4 
#define Bruleur     LATAbits.LA7    // BRL_cde	Commande Relais Brleur		
#define Etat_Bruleur PORTAbits.RA7  // etat du relais Bruleur 

//poids des switches rev 29-04-2024
#define SW0     1	   			
#define SW1     2	
#define SW2     4
#define SW12    6  
#define SW14   18   // 2+16
#define SW3     8 
#define SW31   10   // 8+2
#define SW32   12   // 8+4
#define SW4    16    			
#define SW5    32	

#define Alarm_Inp1  PORTCbits.RC1
#define Alarm_Inp2  PORTCbits.RC2
#define Alarm_Out   LATCbits.LATC0

#define Alarm_Inp1_dir  TRISCbits.TRISC1
#define Alarm_Inp2_dir  TRISCbits.TRISC2
#define Alarm_Out_dir   TRISCbits.TRISC0
#define Status_Relais_Alarme  PORTCbits.RC0

#define BP_Egalisation      PORTCbits.RC5  
#define BP_Egalisation_Dir  TRISCbits.TRISC5  


//04/09/2024 problemo suite fil d'alim coup + alim replace en borne 6 au lieu de 4
// incidence ?? entree RC5 detruite
#define SW6 (PORTC & 0x20)>>5   // SW6 EQUALISATIONsur RC5	
	


#define Def_Pins_PORTA  0b00000000  // 3xDS18B20 + leds + relay bruleur
#define Def_Pins_PORTB  0b11111111  // 5 B.P.
#define Def_Pins_PORTC  0b10100110  // output : UART1 TX ,et  I2C SCL,SDA open collector, BP SW6 input
                                    // RC1 inp alar1,RC2 inp alar2, RC0  out Alarm
#define  Delay_de_Boucle 3          // 3 sec dans Dialogue_Operateur_PC_via_UART.inc

#define ECO 0
#define CFT 1

#define Directory " C:\\MPLABX_Projects\\Chaudiere_Controle_18F27K42_2024.X"
#define Project   " Chaudiere_Controle_18F27K42_2024"
#define Source    " main.c , rev :"
#define Annexe    " XC8 V2.36 C99  Pack: PIC18F-K_DFP 1.6.125"
#define Others    " DS18B20_2024-07.h, OneWire_2023.h\r\n LCD_4bits_I2C_2024-01, UART1_Functions.h, RTC_DS3231_2023-10.h" 
#define Add_Inc1  " Test_all_char_LCD_2023-08.inc, Affiche_LCD_Repos_2024-0904.inc\r\n"  
#define Add_Inc2  " MAJ_RTC_Manuelle_2024-08.inc, Dialogue_Operateur_PC_via_UART_2024-0904\r\n"
#define Add_Inc3  " MENU10_1234_2024-08.inc, MENU4_SW4_2024-0918.inc"
#define Eeprom    " Eeprom_PIC_2024.h,  Eeprom_PIC_2024.c   "

#ifdef Prototype
    #define Hardware " Breadboard or Base 18F27K42  " 
#else
    #define Hardware " Carte PCB Chaudiere"   
#endif

#define Config   " Internal Fosc 64MHz"
#define Schema   " Schema_Chaudiere_V21.1.4.pdf (Kicad)\r\n"
#define With_Test_Presence_Devices 

#include "i2c1_master.h"
#include "i2c1_master_example.h"
#include "OneWire_2023.h"
#include "DS18B20_2024-07.h"  
#include "UART1_Functions.h"
#include "LCD_4bits_I2C_2024-01.h"
#include "Eeprom_PIC_2024.h"
#include "RTC_DS3231_2024-07.h"  
#include "Define_Org.h"

const char Msg0[]=" PIC18F27K42 + 3x OWS sensor DS18B20 sur RA0,RA1,RA2\r\n";
const char Msg1[]=" Directory :"Directory"\r\n";
const char Msg2[]=" Project : "Project"\r\n";
const char Msg3[]=" Source : "Source" version:"VERSION"\r\n";
const char Msg4[]=" Config "Config"\r\n";
const char Msg5[]=" Autres :\r\n "Others"\r\n";
const char Msg6[]=" A inclure: \r\n" Add_Inc2 Add_Inc3"\r\n";
const char Msg7[]=" LCD_chars_Speciaux_2023-0827.h,   Eeprom :"Eeprom"\r\n";
const char Msg8[]=" Hardware :"Hardware"\r\n Schema:"Schema"\r\n";
const char Msg9[]=" RA0,RA1,RA2=3xDS18B20,RA4=led,RA3=SQA,RC6=TX UART1 RC7=RX UART\r\n";
const char MsgA[]=" RB0 interrupt pin, SW0...SW5 + SW6 sur RC5\r\n";
const char MsgB[]=" LCD 4x20 cars + RTC sur bus I2C1 HW : RC3=SCL,RC4=SDA\r\n";
const char * Messages[]={Msg0,Msg1,Msg2,Msg3,Msg4,Msg5,Msg6,Msg7,Msg8,Msg9,MsgA,MsgB};
const char Blancs[]="  ";
  
const char Switches[7][6]={" SW0 "," SW1 "," SW2 "," SW3 "," SW4 "," SW5 "," SW6 "};
  
const char Libelles_Menus_10[13] [7] =
{ //rev 12-04-2024
{"CFTcsg"}, // menu 10.1
{"ECOcsg"},
{"HGLcsg"},
{"INTcor"}, // menu 10.2
{"NRGind"},
{"NRGcor"},
{"CHDmin"}, // menu 10.3
{"CHDmax"},
{"EXTmin"},
{"INThys"}, // menu 10.4
{"EXThys"},
{"EAUhys"},
{"      "}  // efface
};

// rappel fonctions LCD
/*
void LCD_init(void);
void LCD_putcmd(uint8_td,uint8_tcmdtype);
void LCD_Chr_At(int Ligne,int col,uint8_tc1);
void LCD_putch(uint8_td);
void LCD_puts(uint8_t*s);
void LCD_putsRom(const uint8_t*s);
void LCD_Write_CText(const uint8_t*txt) ;
void Erase_Line(int L);
void LCD_At(uint8_tLigne,uint8_t col);
void LCD_Write_Text_At(uint8_tLigne,uint8_tcol, uint8_t* t1);
void LCD_Write_CText_At(uint8_tLigne,uint8_tcol,const uint8_t* t1);
void LCD_Cmd(uint8_td);
void LCD_Load_Custom_Chars(int bavard);  //  10-08-2023 1 seul jeu de car
void LCD_Data(uint8_td);
 */
  
// Flag at 0x0000  + date version programme AAMMJJ\0
// __EEPROM_DATA (0,'2','4','0','8','2','5',0);
// pickit4 Preserve memory 31000-3103FF pour que le rechargement n'ecrase pas le contenu eeprom 
// exemple d'init en asm
// __asm ("ORG 0x310010");
// __asm ("DA 0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37");
// __asm ("DE : 'P','a','u','l','f','j','u',0); 
  
//-------------------------------------------

#define UART1_RX_BUFFER_SIZE 128 
  
// variables Globales usuelles 
unsigned int  i,j,k,l,m,n;
uint8_t c1,c2,c3,cx,cc;

unsigned int Nb_Boucles=0;
volatile uint8_t Buffer1[UART1_RX_BUFFER_SIZE];
volatile unsigned int Index1,i1;
volatile uint8_t Flag_Buffer1=0;
char TEXTE [128];
char * txt;
//uint8_t TEXTE [128];
//uint8_t * txt;
volatile uint8_t Bavard=0;
bool Status_GIE_Bit;  

uint8_t * p0;
uint8_t * p1;
uint8_t * px;

char CRam1[128];
  //  en remplacement de CRam1 dans le traitement des Menus10.1  10.4
char Ram_Menus10[64];   
uint8_t Tampon[32];
unsigned int  Rep;

float Fixed __at(0x0020);
float F0,F1,F2,F3;
float Fm1,Fm2,Fm3;          // reserv aux menus

uint8_t Choix_SW4;
char Dummy;

volatile uint16_t Count0, Count1 ;
volatile uint16_t Cpt0=0;
volatile uint16_t Cpt1=0;   
volatile int16_t  Cpt6=0;   // decompteur
volatile int16_t  Cpt4=0;   // decompteur
volatile uint16_t Cpt2=0;   // compteur sans fin
//volatile uint16_t Clignotant=0; 
volatile uint16_t  Cpt_Bruleur;
unsigned int Duree_Appui=0;
volatile uint16_t Flag_Timer1=0;
volatile uint16_t Flag_Timer2=0;
volatile uint16_t Flag_Timer3=0;
volatile __bit Flag_Timer4=0;
volatile __bit Flag_Timer6=0;

bool Status_GIE_Bit;

#ifdef With_SMT1
    unsigned long SMT1_Measure;
    unsigned char *ST;
#endif
unsigned long L1=0;
unsigned long L2=0;
unsigned long L3=0;

uint8_t HHMN_force=0;
char CH='0';                        // '0'=ETE  '1'=HIVER

// LCD 
volatile uint8_t Addr;
// volatile uint8_t Adresse_7bits;
uint8_t I2_Adresses_Devices[8];
uint8_t tmp[10]={0,0,0,0,0,0,0,0,0,0};
int Etat;

// BP
volatile uint8_t Etats_BP;
volatile uint8_t Etats_IOCBF;
volatile unsigned  int Count_RB0=0;
volatile uint8_t LED_Clignote10=0;      // 1Hz   02-09-2024
volatile uint8_t LED_Clignote05=0;      // 0.5Hz 02-09-2024
// LED_clignote10 = 0  aucune
// LED_clignote10_Parm  = 3 pour LED_Comp jaune (Led4 + LedSW0) = 1Hz
// LED_clignote10_Prog  = 4 pour LED_Pr0g rouge (Led3 + LedSW4) = 1Hz
// LED_clignote10_Eco   = 5 pour LED_Eco  bleue (Led2 + LedSW1) = 1Hz
// LED_clignote10_Conf  = 6 pour LED_Conf verte (Led1 + LedSW2) = 1Hz
// LED_clignote05 = 0  aucune
// LED_clignote05_Parm  = 3 pour LED_Comp jaune (Led4 + LedSW0) = 0.5Hz
// LED_clignote05_Prog  = 4 pour LED_Pr0g rouge (Led3 + LedSW4) = 0.5Hz
// LED_clignote05_Eco   = 5 pour LED_Eco  bleue (Led2 + LedSW1) = 0.5Hz
// LED_clignote05_Conf  = 6 pour LED_Conf verte (Led1 + LedSW2) = 0.5Hz

volatile struct Anybits 
{                                   // 8 flags
    unsigned  Tmr0_Elapsed:1;       // for timer0 16bits
    unsigned  Tmr1_Elapsed:1;       // for timer1 16bits
    unsigned  Tmr2_Elapsed:1;       // for timer2 8bits
    unsigned  Tmr3_Elapsed:1;       // for timer3 16bits
    unsigned  Tmr4_Elapsed:1;       // for timer4 8bits
    unsigned  Tmr6_Elapsed:1;       // for timer6 8bits
    unsigned  NCO_initialise:1;     // for NCO
    unsigned  Key_ON :1;            // detection appui BP
}   Drapeaux ;
 
 uint8_t Flag_Eeprom=0; 

// 2 x 12 bytes pour 24H00 +  8 datas = Nom du programme sur 7 cars + terminateur  , le tout modulo 32
// bloc de 12 x 32= 384 bytes  = 3 blocs de 128 bytes
// en RAM
// reference : Dossier Chauffage (V4.0.1).xls\Tables Programmations
// equivalent  une config USINE si Eeeprom at 0x0000 = 0 ou different de 99
// modif 27/08/2023  dcision reduction nb de table  10

uint8_t  Table_Progr_Horaire_Provisoire[32];
uint8_t  Table_Progr_Horaire_utilisee[32];

// nota : taille  reduire  10 tables au lieu de 12
// uint8_t Tables_Programmations_Horaires[10][32] ={
uint8_t Tables_Programmations_Horaires[12][32] ={
//   
{0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,			
 0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,			
 0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,			
 'C', 'f','2','4','/','2','4',0x00},			
//			
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 'E','c','2','4','/','2','4',0x00},			
//			
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,			
 0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,			
 0x03,0x03,0x03,0x03,0x03,0x03,0x00,0x00,			
 'D' ,'o','m','u','s','>','R',0x00},			
//			
{0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x03,			
 0x00,0x00,0x03,0x03,0x03,0x03,0x03,0x03,			
 0x03,0x03,0x03,0x03,0x03,0x03,0x00,0x00,			
 'M' ,'a','t','i','n','>','T',0x00},			
//	/table #4 Usine=travail journe Retour  midi => 6h-7h + 11h-13h + 17h-22h (modifiable) 		
{0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x03,			
 0x00,0x00,0x00,0x03,0x03,0x00,0x00,0x00, 
 0x00,0x03,0x03,0x03,0x03,0x03,0x00,0x00,			
 'R' ,'e','p','a','s','>','T',0x00},		
//Travail l'Aprs-midi : 7h-13h + 19h-22h			
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,								
 0x03,0x03,0x03,0x03,0x03,0x00,0x00,0x00,							
 0x00,0x00,0x00,0x03,0x03,0x03,0x00,0x00,							
 'A' ,'m','i','d','i','>','T',0x00},			
//			
{0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x03,			
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 0x00,0x03,0x03,0x03,0x03,0x03,0x00,0x00,			
 'J' ,'o','u','r','>','T',' ',0x00},		 // bug corrig 27-09-2024	
//			
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 'P' , '>', 'P', 'e','r' , 's', '1',0x00},
//			
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 'T' , '>', 'P', 'e','r' , 's', '2',0x00},		
 // ---table #9   pour Tests only !-------
{0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
 0x02,0x01,0x01,0x01,0x00,0x00,0x00,0x00,  
 'V' , '>','P', 'e', 'r', 's' ,'3', 0x00},
//----------------------------------------
 {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	   
 'W' ,0x00,0x00,0x00,0x00,0x00,0x00,0x00},
//----------------------------------------   
 {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,			
 'Z' ,0x00,0x00,0x00,0x00,0x00,0x00,0x00}   
};

char Jour_en_cours;     // 0  6 // was 1  7
char Jour_Select;       // 0  6 // was 1  7
char Progr_Select=0;    // 'C' = Confort
uint8_t Demi_Heure_En_Cours=0;
int  Minutes_En_Cours=0;

// ----date et RTC -----
const char All_Jour_Semaine[]="LuMaMeJeVeSaDiEr"; // pour LCD ligne 4 position 3 et 4

const char Jour0[]="Lundi   ";
const char Jour1[]="Mardi   ";
const char Jour2[]="Mercredi";
const char Jour3[]="Jeudi   ";
const char Jour4[]="Vendredi";
const char Jour5[]="Samedi  ";
const char Jour6[]="Dimanche";
const char Jour7[]="Error   ";
const char * JourSemaine[]={Jour0,Jour1,Jour2,Jour3,Jour4,Jour5,Jour6,Jour7};

char time[]="00H00M00S";
char date[]="00/00/00";
char Controle_Chaudiere=0;
char Pas_Progr_Horaire=0;
int  Duree_Boucle=0;
int  dummy;
uint8_t UnByte=0;
// pour Zone Test seulement
// char  TIMER1_OVFL = 0;  

//----------- 10  programmes ----W,Z non utiliss--------------------
const char Progr_Name[12]={'C','E','D','M','R','A','J','P','T','V','W','Z'};
// ATTENTION : W et Z ..PAS de traitement particulier !
// Affectation_Hebdo
// les chiffres correspondent  l'index Progr_Name 
// et aussi 1er index de  Tables_Programmations_Horaires[12][32] 
uint8_t Affectation_Hebdo[8]={5,4,3,6,6,5,2,0};  // le dernier byte inutilis (remplissage) 


uint8_t Progr_En_Cours=0;       // 9=table V pour les tests
				
// --- MENU PRINCIPAL ------
volatile uint8_t Menu=0;
volatile uint8_t MPas=0;

// ---- SOUS Menus --------
// volatile uint8_t SMenu=0;
volatile uint8_t SPas=0;
uint8_t PosX=0;
uint8_t Valeur=0;
uint8_t cd,cu;   
volatile uint8_t Old_SPas=0;
uint8_t Contenu_Ligne_LCD_En_Cours[21];  
// variables intermedaire AVANT validation modif  dans les menus
float Dummy1,Dummy2;

// nota : les mesure brutes de temperatures utilisent des variables flottantes
// F1,F2,F3  usage gnral,non specialement affectes
float INT_mes=19.0;             // mesure brute sonde#1 DS18B20 F1 + correction 
float EXT_mes=-5.0;             // mesure brute sonde#2 DS18B20 F2 + correction 
float EAU_mes=10.0;             // mesure brute sonde#3 DS18B20 F3 + correction 
float Txcor[3]={0.0,0.0,0.0};   // correction pour les 3 sondes

// ---------- Parametres -----------------------------------
// int Choix_NRG_cor=6;         //facteur de performance nergtique 
// modif 25-03-2024 voir email
// int NRG_cor[]={45,38,32,27,26,20,18,19}; //tableau de correspondance  parmi A, B, C, D , E, F, G 
#define Max_NRG_cor 5.0
#define Min_NRG_cor 0.5         // was 0.0 correctif HT 10/08
float NRG_cor =     3.0;
#define Max_INT_cor 2.0
#define Min_INT_cor 0.0
float INT_cor =     0.5;        // Sans correction TC ressentie (0, au demi C)
char NRG_ind='G';               // soit A=7  ..   H=0 
// limites  
float EXT_min =   -10.0;   
float EAU_min =    35.0;
float EAU_max =    80.0;

//new 09-04-2024 en positif  .. seront retranches des mesures
#define Max_HYS_int 1.5
#define Min_HYS_int 0.5
float HYS_int	=	0.5;	// Valeur Hystrsis de Reprise (Sonde INT) ; Arrt = 0  {-0.5,-1.00,-1.50};				
#define Max_HYS_ext 1.5
#define Min_HYS_ext 0.5
float HYS_ext	=	0.5;	// Valeur Hystrsis de Reprise (Sonde EXT) ; Arrt = 0, {-0.5,-1.00,-1.50};				
#define Max_HYS_eau 3.0
#define Min_HYS_eau 1.0
float HYS_eau	=   1.0;    // Valeur Hystrsis de Reprise (Sonde EAU Chaudire) ; Arrt = 0	,{-2.00,-3.0,-4.00};	

int   CHX_mod   =   1;      // choix mode  0=HGEL 1=Confort 2= eco
float CHD_max   =  85;      // Limite TC max constructeur (85, au C)
float CHD_min   =  30;      // step 5
float CHD_cor   =   0.50;   // Choix indice performance energetique ("G"=>18) en cours

// data calcules 
float INT_cbl;
float CFT_cbl;     
float ECO_cbl;
float Pente;
float Offset;
int   EAU_cbl;

//-------- consignes ------------------
#define Max_CFT_csg 28.0
#define Min_CFT_csg 16.0
float CFT_csg     = 19.0;       // Consigne TC confort de base (19, au demi C)
#define Max_ECO_csg 18.0
#define Min_ECO_csg 12.0
float ECO_csg     = 15.0;       // Consigne TC eco de base (15, au demi C)
#define Max_HGL_csg 10.0
#define Min_HGL_csg  5.0    
float HGL_csg     = 10.0;       // step 1C 
float CSG_En_Cours= 19.0; 

// ---- Programmation chauffage ----

uint8_t Requete_Bruleur=0;
//  0 = non forc ; 1  <= ECO momentan ; 2  >= Confort Forc
uint8_t Forcage_Consigne   =0;  // 0=NORMAL ; 1=FORCE
uint8_t Choix_Conf_Eco     =0;
uint8_t Choix_Conf_Consigne=0;  // 0=ECO ; 1= Confort ; 2=HGEL 
uint8_t Choix_Hors_Gel =0;

uint8_t Forcage_Mode   =0;      // 0=NORMAL ; 1=FORCE
uint8_t Forcage_Mode_at=0;
uint8_t Mode_Progr     =0;
uint8_t Mode_En_Cours  =1;      // 0=ECO ; 1= Confort Cf ; 2=Hors gel
uint8_t Valeur_Progr;           // 0=Heure ECO ; 1=1ere demi-H CFT ; 2=2em demi-H CFT ; 3=Heure CFT
float Valeur_En_Cours=0.0;
uint8_t Aff_CHX_mod[3][3]={"Ec","Cf","Hg"};  // 3 strings de 2 lettres se terminant par un Zero! 

uint8_t Alarmes=0;
uint8_t Etat_Alarme;

#define fleche_H  4             // char special LCD
#define fleche_B  5             // char special LCD
#define vide     32             // ascii espace
char LCD_char12=' ';            // caractere variable en position 12 affichage repos LCD
char LCD_char15=' ';            // caractere variable en position 15 Affichage repos  LCD
//------------------------------------------------------------------------------

//--- li aux capteur DS18B20 ---
char Demande_Equalisation=0;
char Demande_Restauration_Param_Usine=0;

uint8_t Dec2Bcd(uint8_t n);    
uint8_t Bcd2Dec(uint8_t val);

char Plage=0;
char OldDeb=0;
char Deb=0;

//----------- Menus SW0 -----------------------
void Affiche_Ligne2_Menu10(void);
void Clignote_Selection(int Mx);
void Sortie_Menu10(void) ;
void Test_Sortie_Via_SW0(void);
void MENU10_1_CONSIGNE_INT(void);   // 1
void MENU10_2_COMPENSATION(void);   // 10-04/2024
void MENU10_3_LIMITES_CHD(void);    // 12-04-2024
void MENU10_4_HYSTERESIS(void);     // 12-04-2024

void Terminaison_Menu_Direct(void);
void Affiche_MENU_Etalonnage_Sondes(void);
void MAJ_RTC_Manuelle(void);        // appel par menu SW5 direct
void Affiche_LCD_Repos(void);
void Affectation_Programme_au_Jour_Semaine();
void Affiche_Plages_Programme_Horaire(uint8_t Prg); //  suivre
void Modification_Programmation_Horaire(void);

void Affiche_3_mesures_DS18B20_sur_LCD(char Avec_Corr);
void Sauve_Parametres_en_Eeprom(uint16_t ad) ; // parametre = adresse de depart en Eeprom Travail ou USINE
void Charge_Param_Travail (uint16_t ad);      
// void Restitue_Parametres_Travail_depuis_Eeprom(char choix);  
void Calcul_Consigne_Eau_Chaudiere(void);
//void Calcul_Consigne_Eau_Chaudiere_by_HT(char bavard) ;
 
void Vectored_Interrupts_Init(void);
void Hardware_Init();
// void Init_Timer0_10S();          // 10 sec  
void Init_Timer0_10S(char Avec_IT); // 10 sec  
void Restart_Timeout(void);
void Init__To_Va(signed int Va);
void Init_Timer4(void);
void Init_Timer2(void);
void Timer2_OFF(void);
void Init_Timer2(void);
void Equalisation_3_DS18B20(void);

void TMR6_Init_500ms(char N);
void Delay_100mS(void);

#ifdef With_SMT1
    void SMT1_Init(char Choix_SMT1_Clock); // clock 64MHz,16Mhz,500Khz,31,25Khz
#endif

//void Init_I2C (void);
void I2C1_Write1ByteRegister(i2c1_address_t address, uint8_t reg, uint8_t data);
void I2C_PCF8574_Write(uint8_t Addr, uint8_t value);

void BCD_To_Ascii(uint8_t cc,uint8_t * px);
uint8_t Bcd2Dec(uint8_t v1);
uint8_t Dec2Bcd(uint8_t  n);
   
// long jour2jul(char jour , char mois , int annee);
// char *j_txt(long n , char *num);
//--------------------------------------------
void __delay_xSec(uint8_t N);
void Verif_contenu_Eeprom_Table_Programmes_Horaires(uint16_t n);


//-------------------------------------------
// voir Eeprom_PIC.c
// uint8_tDATAEE_ReadByte(int bAdd);
// void DATAEE_WriteByte(int bAdd, uint8_tbData);
// void Sauve_Float_To_Eeprom(unsigned int ad1,float Fv);
// float Read_Float_from_Eeprom(unsigned int Adresse) ;

#define FLASH_ROW_ADDRESS       0x1FFFF     
#define FPAGE_SIZE              128
#define MAX_FLASH_ADRESS        0x1FFFF    
#define WRITE_FLASH_BLOCKSIZE   128
#define ERASE_FLASH_BLOCKSIZE   128
#define END_FLASH               0x20000    // 131071)

void  Vectored_Interrupts_Init(void)
{   //rev 25-10-2023
    bool state = (uint8_t)  INTCON0bits.GIE;
    INTCON0bits.GIE  = 0;
    INTCON0bits.IPEN = 1;
    INTCON0bits.GIEH = 0; // dis high priority interrupts
    INTCON0bits.GIEL = 0; // dis low priority interrupts*
     
    INTCON0bits.IPEN = 1; // Enable interrupt priority
    // __asm("BCF INTCON0,GIE");
    // GIE = 0;
    IVTLOCK  = 0x55;
    IVTLOCK  = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x00; // unlock IVT
    IVTBASEU = 0;
    IVTBASEH = 0;
    IVTBASEL = 8;
    IVTLOCK  = 0x55;
    IVTLOCK  = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x01; // lock IVT
    // Assign peripheral interrupt priority vectors
    IPR3bits.U1RXIP = 1;
    IPR1bits.INT0IP = 1;
    IPR4bits.TMR1IP = 0;
    IPR3bits.TMR0IP = 0;
    IPR4bits.TMR2IP = 0;  // low priority
    IPR7bits.TMR4IP = 0;
    IPR9bits.TMR6IP = 0;
    IPR0bits.IOCIP  =  0;
  
    INTCON0bits.GIEL = 1; // Enable low priority interrupts
    INTCON0bits.GIEH = 1; // dis high priority interrupts
    INTCON0bits.GIE  = state;
}

void __interrupt(irq(IRQ_INT0),high_priority) INT0_ISR(void)
{   //rev 05/09/2023
    unsigned int OverTime;
    uint8_t i;
    uint8_t ck;
    uint8_t kb;
    if( (INT0IE) && (INT0IF))
    {    
        Drapeaux.Key_ON=0;
        Etats_BP=0;
        U1TXB='#';
        __delay_ms(80);  // 02/12 modif delay minimum anti rebonds contact sec (was 60mS)
        // elimine bit RB0 
        Etats_BP =IOCBF >> 1;  
        __delay_ms(40); 
        OverTime=0;
        while( (PORTB & 0x7F)!=0x7F)
        {  
            __delay_us(100);
            OverTime++;
            if (OverTime>60000) goto exit1;  
        }    
        Drapeaux.Key_ON=1; 
        Duree_Appui=OverTime/10;
        if ( (Etats_BP==SW0) && (Duree_Appui<1000) ) // Appui Court
        {
            if (Menu==0) 
            {
                Menu=10;
                SPas=0;
                MPas=1;
                // Etats_BP=0; // 09-12
            }            
        }    
        else 
        {
            // Detection actions sue BP pour les entres en Menu
            if ( (Menu<4) && (Duree_Appui<1000) )   // Accs Courts (<1s))
            { 
                if (Etats_BP==SW1)  Menu=1; // SW1(2)  Bascule Mode Cf ou EC
                if (Etats_BP==SW2)  Menu=2; // SW2(4)  Incrment Consigne par pas de 0.5
                if (Etats_BP==SW3)  Menu=3; // SW3(8)  Dcrment Consigne par pas de 0.5
            }    
            if ( (Menu<10) && (Duree_Appui>1000) && (Duree_Appui<6000) ) // Accs Longs (>1s <6s)
            {  
                // if (Etats_BP==SW0)  Menu=0;          
                if (Etats_BP==SW4)  Menu=4; // SW4(16)             Affectation Programme ou Modif Programme
                if (Etats_BP==SW5)  Menu=5; // SW5(32)             Mise  Jour RTC
                if (Etats_BP==SW12) Menu=6; // SW1+SW2 = 2+4 =  6  Arret Total
                if (Etats_BP==SW31) Menu=7; // SW1+SW3 = 2+8 = 10  Bascule consigne Hors gel ou Normal
                if (Etats_BP==SW32) Menu=8; // SW2+SW3 = 4+8 = 12  RAZ Alarmes  Chaudire Acquites
            }
        }        
    /*   
        else // Initialement, tous accs Menus et Actions Directes taient en Appui Long (sauf SW0)
        {
            if ( (Menu<10) && (Duree_Appui>1000) && (Duree_Appui<6000) ) 
            {  
                // detection Entrees dans Menus directs 
                // if (Etats_BP==SW0)  Menu=0;
                if (Etats_BP==SW1)  Menu=1; // SW1(2)          Bascule Mode Cf ou EC
                if (Etats_BP==SW2)  Menu=2; // SW2(4)          Incrment Consigne par pas de 0.5
                if (Etats_BP==SW3)  Menu=3; // SW3(8)          Dcrment Consigne par pas de 0.5 
                if (Etats_BP==SW4)  Menu=4; // SW4(16)         Affectation Programme ou Mdif Programme
                if (Etats_BP==SW5)  Menu=5; // SW5(32)         Mise  Jour RTC
                if (Etats_BP==SW12) Menu=6 ;// SW1+SW2=2+4=6   Arret Total
                if (Etats_BP==SW31) Menu=7; // SW1+SW3 =2+8=10 Bascule consigne Hors gel ou Normal
                if (Etats_BP==SW32) Menu=8; // SW2+SW3 =4+8=12 RAZ Alarmes Chaudire Acquites  
            }
        }
    */
    }  
    exit1: 
    // if(Drapeaux.Key_ON==0) Etats_BP=128;
    // Count_RB0++;
    PIR0bits.IOCIF=0;
    IOCBF=0;
    INT0IF=0;   
    // INTCON0bits.GIEL=0;
}

void __interrupt(irq(IRQ_U1RX),high_priority) UART1_rx_vect_isr(void)
{
    static char cx;
    // U1TXB='H';  // pour debugging only
    if ( (PIR3bits.U1RXIF==1) && (PIE3bits.U1RXIE ==1) )
    {   
        c1=U1RXB;       // => RAZ PIR3bits.U1RXIF
        // U1TXB='*';   // echo
        if ((c1==13) || (i1>UART1_RX_BUFFER_SIZE-1))
        { 
            Flag_Buffer1=1;
            Buffer1[i1]=0;
            Index1=i1;
            i1=0; 
            PIE3bits.U1RXIE =0;
        }
        else
        {
            Buffer1[i1]=c1;
            i1++;
            Index1=i1;
        } 
    } 
    // INTCON0bits.GIEL=0;
}

void __interrupt(irq(IRQ_TMR0),low_priority)TMR0_ISR(void)
{        
    // U1TXB='';
    Cpt0++;   // nombre de timeout
    Drapeaux.Tmr0_Elapsed=1;
    // complement=65536-26236=39300pour TMR0 10sec		
    TMR0H   = 0x66;  // 26236				
    TMR0L   = 0x7C;	
    PIR3bits.TMR0IF = 0;
}

void __interrupt(irq(IRQ_TMR2),low_priority)TMR2_ISR(void)
{  
    // U1TXB='%';
    Cpt2++;         // peut evoluer de 0  65535..0...
    Flag_Timer2=1;
    T2PR=194;
    if ((Cpt2 %10)==0) Drapeaux.Tmr2_Elapsed=1;   //100mS x10 => 1sec
    PIR4bits.TMR2IF=0;
}

void __interrupt(irq(IRQ_TMR4),low_priority) TMR4_ISR(void)
{  
 //   Cpt_Bruleur++;
//    if ( (Requete_Bruleur==1)  && (Cpt_Bruleur >40) ) // latence  de  40x0,25= 10sec
 //   {
//      Bruleur=ON;
 //     Cpt_Bruleur=0;
 //    }
//    if ( (Requete_Bruleur==0)  && (Cpt_Bruleur >40) ) // latence  de  40x0,25= 10sec
//   {
 //     Bruleur=OFF;
 //     Cpt_Bruleur=0;
 //   }
    Cpt4++;
    //  Clignotant++;           // affect au clignotement des leds
    if (LED_Clignote10 > 0)  // 1 fois sur 2 !  1Hz
    {
           if((LED_Clignote10 & 0x03)==0x03)  __asm("btg LATA,3");  // Led4 jaune LedSW0
           if((LED_Clignote10 & 0x04)==0x04)  __asm("btg LATA,4"); // Hardware = Led3 rouge LedSW4
           if((LED_Clignote10 & 0x05)==0x05)  __asm("btg LATA,5"); // Hardware = Led2 verte LedSW2
           if((LED_Clignote10 & 0x06)==0x06)  __asm("btg LATA,6");// Hardware = Led1 bleue LedSW1
    }
    if (LED_Clignote05 > 0) 
    {
        if((LED_Clignote05 & 0x03)==0x03)  __asm("btg LATA,3");  // Led4 jaune LedSW0
        if((LED_Clignote05 & 0x04)==0x04)  __asm("btg LATA,4"); // Hardware = Led3 rouge LedSW4
        if((LED_Clignote05 & 0x05)==0x05)  __asm("btg LATA,5"); // Hardware = Led2 verte LedSW2
        if((LED_Clignote05 & 0x06)==0x06)  __asm("btg LATA,6");// Hardware = Led1 bleue LedSW1
     }    
     Flag_Timer4=1;
     T4PR=244;
     TMR4IF=0;// clear the TMR4 interrupt flag
}    

void __interrupt(irq(IRQ_TMR1),low_priority) TMR1_ISR(void)
{  
    // timer1 autoscroll at 65535+1
    Flag_Timer1=1;
    U1TXB='@';
    // __asm("btg LATA,4"); // toggle  LED_rouge 
    TMR1IE=0;
    TMR1IF=0;               // clear the TMR1 interrupt flag
 }

void __interrupt(irq(IRQ_TMR6),low_priority) TMR6_ISR(void)
{  
    if (Cpt6>0) // decomptage maxi 32767
    {
        Cpt6--;
    }
    else
    {
        Drapeaux.Tmr6_Elapsed=1;
        TMR6IE=0;
    } 
    Flag_Timer6=1;
    TMR6IF=0;   // clear the TMR6 interrupt flag
}


void Init_Timer4(void)      // 0.5 ou 1Sec (avec 500Khz!)
{ 
    T4CON    = 0x00;
    T4CLK=0x05;  // choix clock : 5=500Khz ; 1= FOSC/4 ; 0=FOSC
    // T4CONbits.CKPS2=1;   // 7=> 1/128 ; 4 => div 1/16 
    // T4CONbits.CKPS1=1;
    // T4CONbits.CKPS0=1;
    // T4CONbits.CKPS=7;
    T4CONbits.CKPS=7;
    // bit 3-0 OUTPS[3:0]: Timerx Output Postscaler Select bits
    // 1111 = 1 : 16 Postscaler ; 0000 = 1 : 1 Postscaler
    // T4CONbits.OUTPS=15;  // div 1/(15+1)= 1/16 ... =2*128*16*(244+1)
    // T4CONbits.OUTPS=7;   // div 1/(7+1) = 1/8  ... =2*128* 8*(244+1)
    T4CONbits.OUTPS=7;      // 5  7 7 -> 0.5" ; 5  7 3  -> 0.25"
    T4PR=244;  
    T4TMR=0;
    T4RST=0x00;  
    Cpt4=0;
    Cpt_Bruleur=0;
    //Clignotant=0;
    Drapeaux.Tmr4_Elapsed=0;
    PIE7bits.TMR4IE=1;
    PIR7bits.TMR4IF=0;
    T4CONbits.T4ON=0;
} 

#include "Affiche_LCD_Repos_2024-0904.inc"

void Equalisation_3_DS18B20(void)
{
    CPrint(" Demande AUTO_etalonnage des 3 sondes DS18B20\r\n");
    CPrint(" elles doivent etre reliees mecaniquement ensembles (meme temperature ambiante)\r\n");
    sprintf(CRam1," Attente relache SW6 ..puis appui sur SW6 \r\n"); 
    Print (CRam1);
    LCD_Cmd(LCD_CLEAR);
    LCD_Write_CText_At(1,1,"Relacher SW6        ");
    do
    {} 
    while(SW6==0);  // attente relache SW6
    // gabarit 12345678901234567890
    LCD_Cmd(LCD_CLEAR);
    LCD_Write_CText_At(1,1,"Demande EGALISATION ");
    LCD_Write_CText_At(2,1," Les sondes doivent ");
    LCD_Write_CText_At(3,1,"etre liees ensemble ");
    LCD_Write_CText_At(4,1,"Valider par SW6>2sec");
              
    // Attente validation par SW6 appyu > sec
    // les 2 leds clignotent en alternance
    LED_vert=1;
    LED_rouge=0;
    while (SW6==1)
    {      
        __asm("btg LATA,6");  // LED_verte 
        __asm("btg LATA,4");  // LED_rouge 
        __delay_ms(20);
    }
    i=0;
    while (SW6==0) // duree BP appuye
    {   
        __delay_ms(100);
        i++;
        __asm("btg LATA,6");  // LED_verte 
        __asm("btg LATA,4");  // LED_rouge 
        if (i>20) break;
    }
    if (i<20) 
    {                    
        Erase_Line(1);
        Erase_Line(2);  // 12345678901234567890                     
        LCD_Write_CText_At(3,1,"Delai SW6 trop court");
        LCD_Write_CText_At(4,1,"Demande avortee !.. ");
        __delay_xSec(4);
        Demande_Equalisation=0;
        __asm("reset");
    }       
    LCD_Write_CText_At(4,1,"Demande Acceptee ..");       
    __delay_xSec(2);  
           
          
    //   Affiche_3_mesures_DS18B20_sur_LCD;(0);
    CPrint(" Mesures brutes\r\n");   
    LCD_Cmd(LCD_CLEAR);
            
    F1= getTemperature1();  
    sprintf(txt," T1.INT. = %5.3f%cC",F1,176);
    Print(txt);CRLF1();
    *(txt+17)=7; // degre C
    LCD_Write_Text_At(2,1,txt);

    F2= getTemperature2();
    sprintf(txt," T2.EXT. = %5.3f%cC",F2,176);
    Print(txt);CRLF1();
    *(txt+17)=7; // degre C
    LCD_Write_Text_At(3,1,txt);
   
    F3= getTemperature3();
    sprintf(txt," T3.EAU. = %5.3f%cC",F3,176);
    Print(txt);CRLF1();
    *(txt+17)=7; // degre C
    LCD_Write_Text_At(4,1,txt);
    __delay_xSec(2);
                     
    F0=(F1+F2+F3)/3.0;
    // 12345678901234567890 
    sprintf(txt," MOYENNE = %5.3f%cC",F0,176);
    Print(txt);CRLF1();
    *(txt+17)=7; // degre C
    LCD_Write_Text_At(1,1,txt);
    __delay_xSec(3);
         
    CPrint("Calcul des corrections :\r\n");
    Txcor[0]=F0-F1;
    Txcor[1]=F0-F2;
    Txcor[2]=F0-F3; 
    CPrint(" Mesures issues de l' Egalisation :\r\n");
    // resultats sur LCD
    LCD_Cmd(LCD_CLEAR);   
    // Erase_Line(1);     
    LCD_Write_CText_At(1,1," Results Egalisation"); 
    Erase_Line(2); 
    // gabarit 12345678901234567890
    sprintf(CRam1,"T1 %3.2f%c corr=%2.2f%c",F1,7,Txcor[0],7);
    LCD_Write_Text_At(2,1,CRam1);
    // Erase_Line(3); 
    sprintf(CRam1,"T2 %3.2f%c corr=%2.2f%c",F2,7,Txcor[1],7);
    LCD_Write_Text_At(3,1,CRam1);
    // Erase_Line(4); 
    sprintf(CRam1,"T3 %3.2f%c corr=%2.2f%c",F3,7,Txcor[2],7);
    LCD_Write_Text_At(4,1,CRam1);
            
    sprintf(txt," T1.INTER = %5.3f%c C  T1cor=%2.3f",F1,176,Txcor[0]);
    Print(txt);CRLF1();
    sprintf(txt," T2.EXT   = %5.3f%c C  T2cor=%2.3f",F2,176,Txcor[1]);
    Print(txt);CRLF1();
    sprintf(txt," T3.EAU   = %5.3f%c C  T3cor=%2.3f",F3,176,Txcor[2]);
    Print(txt);CRLF1();  
    __delay_xSec(4);
          
    LCD_Cmd(LCD_CLEAR);   // 123456787901234567890
    LCD_Write_CText_At(1,1,"  Appuyer sur SW6    ");  
    LCD_Write_CText_At(2,1,"  pendant > 2 Sec    "); 
    LCD_Write_CText_At(3,1,"  pour valider       ");
    CPrint(" Appuyer sur SW6 pendant >2sec pour valider\r\n"); 
    i=0;
    // les 2 leds clignotent en alternance
    LED_vert = 1;
    LED_rouge= 0;
    while (SW6==1)
    {  
        __asm("btg LATA,6");    // LED_verte 
        __asm("btg LATA,4");    // LED_rouge 
        __delay_ms(20);
    }
    i=0;
    while (SW6==0)              // duree BP appuye
    {   
        __delay_ms(100);
        i++;
        __asm("btg LATA,6");    // LED_verte 
        __asm("btg LATA,4");    // LED_rouge 
        if (i>20) break;
    }
    if ( (SW6==0) && (i>19) )   // appui>=2sec
    {
        LED_vert = 1;
        LED_rouge= 0;
        CPrint(" Sauvegardes corrections en Eeprom en 0x0050, 0x0054, 0x0058\r\n");
        Sauve_Corrections_Temper(); 
        CPrint(" Fin Auto etalonnage 3 sondes DS18B20\r\n");
        LCD_Cmd(LCD_CLEAR);
        LCD_Write_CText_At(1,1," FIN...OK.......... ");  
        LCD_Write_CText_At(2,1,"Sauve  corrections  "); 
        LCD_Write_CText_At(3,1,"dans Eeprom PIC     ");
        __delay_xSec(3);
    }
    CPrint(" Rechargement corrections capteurs DS18B20 depuis Eeprom\r\n");
    Restitue_Corrections_Temper();
    // Txcor[0]= Read_Float_from_Eeprom(Org_Txcor);
    sprintf(CRam1," Temp 1 corrigee= %5.3f  \r\n",F1+Txcor[0] );
    Print(CRam1);     
    // Txcor[1]= Read_Float_from_Eeprom(Org_Txcor+4);
    sprintf(CRam1," Temp 2 corrigee= %5.3f  \r\n",F2+Txcor[1] );
    Print(CRam1);  
    // Txcor[2]= Read_Float_from_Eeprom(Org_Txcor+8);
    sprintf(CRam1," Temp 3 corrigee= %5.3f  \r\n",F3+Txcor[2] );
    Print(CRam1);   
    __delay_xSec(3);
    CRLF1();   
    CPrint ("\r\n Attente remise en place des 3 capteurs,et RESET pour sortir \r\n");
    LED_vert=0;
    LCD_Cmd(LCD_CLEAR);  
    LCD_Write_CText_At(1,1,"EGALISATION terminee");
    LCD_Write_CText_At(2,1,"Remettre en place   ");
    LCD_Write_CText_At(3,1,"Les 3 sondes DS18B20");
    LCD_Write_CText_At(4,1,"puis BP RESET ...   ");
    // attente Reset
    while(1)  // boucle infinie !
    {
        __asm("btg LATA,4");  // LED_rouge  
        __delay_ms(100);
    }             
}

// Conversion du code BCD en chiffre decimal
uint8_t Bcd2Dec( uint8_t val)
{
    return ( (val>>4)*10 + (val%16) );
}

void BCD_To_Ascii( uint8_t cc, uint8_t * px)
{
    *(px)  = (cc>>4) + 48;
    *(px+1)= (cc & 0x0F) + 48;
    *(px+2)= 0;
}

uint8_t Dec2Bcd(uint8_t n)
{
    return (n / 10 * 16 + n % 10);
}

uint8_t Ascii_Paire_To_BCD(uint8_t *px)
{ 
    static uint8_t cx=0;
    uint8_t cd, cu;
    cd = *(px)-48;
    cx = cd << 4;
    cu = *(px+1)-48;
    cx = cx+cu ;
    return (cx);
}  

//------------------------------------------------------
  
void __delay_xSec(uint8_t N)
{
    static int i2;  
    for (i2=0;i2<N;i2++) __delay_ms(1000);
}

void Verif_contenu_Eeprom_Table_Programmes_Horaires(uint16_t n)
{  
    uint16_t i,k;
    uint8_t cx;
    k = (n<<5) + Org_Sauve_Progr_Travail ;  
    sprintf(CRam1,"\r\nVerif 0x%04X  Nom : ",k);
    Print(CRam1);
    for (i=24;i<31;i++)
    {  
        cx= DATAEE_ReadByte(k+i); 
       // __delay_ms(25);
        PrintChar(cx);          
    }
    CRLF1(); 
    //------------------MATIN ---------
    for (i=0;i<12;i++)
    {    
        cx= DATAEE_ReadByte(k+i); 
        //__delay_ms(25);
        sprintf(CRam1," 0x%02X,  ",cx);
        Print(CRam1); 
    } 
    CRLF1();
    //---------------- APRES MIDI ---------
    for (i=0;i<12;i++)
    {    
        cx= DATAEE_ReadByte(12+k+i); 
        //__delay_ms(25);
        sprintf(CRam1," 0x%02X,  ",cx);
        Print(CRam1); 
    }
    CRLF1();
}

void I2C_PCF8574_Write(uint8_t Adrp,uint8_t value)
{   // rev 14-10-2023 
    uint8_t tmpx[2];
    tmpx[0]=value;
    tmpx[1]=0;
    I2C1_WriteNBytes( Adrp, tmpx, 1); 
    __delay_us(30);
} 

void Init_Timer0_10S(char Avec_IT)  // 10 sec  
{
    T0CON0bits.EN=0;
    T0CON0bits.MD16=1;
    // postscaler=0 => 1/1
    T0CON0bits.OUTPS3=0; 
    T0CON0bits.OUTPS2=0;
    T0CON0bits.OUTPS1=0;
    T0CON0bits.OUTPS0=0;
    // CS[2:0]:Timer0 Clock Source Select bits  
    // 101 = MFINTOSC (500 kHz)
    T0CON1bits.CS2=1;
    T0CON1bits.CS1=0;
    T0CON1bits.CS0=1;
    T0CON1bits.ASYNC=1;     //1=asynhrone ; 0=synchrone avec fosc/4
    // CKPS[3:0]: Prescaler =7 => Rate Select bit => div  1/128
    T0CON1bits.CKPS3=0; 
    T0CON1bits.CKPS2=1;
    T0CON1bits.CKPS1=1; 
    T0CON1bits.CKPS0=1; 
    // complement=65536-26436=39100 ; 500Khz=> T=2S
    // => 2 * 39100 * 128 * 1 = 10 009 600 S
    TMR0H = 0x67;           // 26436
    TMR0L = 0x44;
    // IPR3bits.TMR0IP=1;   // high level interrupt
    Cpt0=0;
    Drapeaux.Tmr0_Elapsed=0;
    PIR3bits.TMR0IF=0;
    if(Avec_IT==1)
    PIE3bits.TMR0IE=1;
    else
    PIE3bits.TMR0IE=0;      // pooling par defaut
    T0CON0bits.EN=1;
}

void Restart_Timeout()  
{   // => 2 * 39100 * 128 * 1 = 10 009 600 S
    T0CON0bits.EN=0;
    TMR0H = 0x67;           // 26436
    TMR0L = 0x44;
    Cpt0=0;
    Drapeaux.Tmr0_Elapsed=0;
    PIR3bits.TMR0IF=0;
    T0CON0bits.EN=1;
}

void Timer2_OFF()
{
    Flag_Timer2=0;
    PIE4bits.TMR2IE=0;
    PIR4bits.TMR2IF=0;
    T2CONbits.T2ON=0;
}  

void Init_Timer2()      // 100mS  mS avec FOSC=500KHz 
{ 
    T2CON = 0x00;
    //clock 
    T2CLK =0x05;        // 5=500Khz ; 1= FOSC/4 ; 2=FOSC
    // prescaler
    T2CONbits.CKPS2=1;  // 5 => 1/32 
    T2CONbits.CKPS1=0;
    T2CONbits.CKPS0=1;
    // T2CONbits.CKPS=3;
    T2CONbits.OUTPS=7;  // => div 1/32
    T2PR=194;           // 2 * 32 * 8 * (194+1) => 99840 S soit~ 100 mS 
    T2TMR=0;
    // REGISTER 22-2 : TxRST: TIMER2 EXTERNAL RESET SIGNAL SELECTION REGISTER p337
    T2RST=0x00;  
    Cpt2=0;
    Drapeaux.Tmr2_Elapsed=0;     
    Flag_Timer2=0;
    PIE4bits.TMR2IE=1;
    PIR4bits.TMR2IF=0;
    T2CONbits.T2ON=1;
}

void TMR6_Init_500ms(char N)
{   
    // cycle=500 mS modifi -> 1sec !
    PIE9bits.TMR6IE=0 ;
    // T2PSYNC Not Synchronized; T2MODE Software control; T2CKPOL Rising Edge; T2CKSYNC Not Synchronized; 
    T6CLKCON = 0x05;        // T2CS FOSC/4 ou 0x05 pour 500Khz
    T6HLT = 0x00;
    T6TMR = 0x00;           // TMR4 0; 
    T6CON = 0x70 | 0x07 ;   // Prescaler = 7 => 1/128 ; Poscaler = 7 => 1/8 =>  ticks = 512 S
    T6PR=244;               // 512 * (244+1) * 128 * 8 => 501760S -> 500mS sec
    // Flag_Timer6=0;
    Drapeaux.Tmr6_Elapsed=0;
    TMR6IF=0;
    if (N>0) 
    { 
        Cpt6=N-1;           // -1 pour Nb de boucle exact!
    }
    else
    {
        Cpt6=0;             // 1 seule boucle de 0.5sec
    } 
    PIE9bits.TMR6IE=1 ;     // TMR6IE_bit=1;
    TMR6IF=0;   
    TMR6ON = 1;
 }

void Delay_100mS()
{
    T4CONbits.T4ON=1;       // start Timer4
    while( PIR7bits.TMR4IF==0);
    PIR7bits.TMR4IF=0;
    T4CONbits.T4ON=0;       // stop timer4   
}

// -------------------------------------------------

void Hardware_Init(void)
{   // rev 29/03/2024
    LATA = 0x00;
    LATB = 0xFF;
    LATC = 0xFF;
    
    TRISA = 0x00;  
    TRISB = 0xFF;
    TRISC = 0b10100110;  // 05-09-2024
         
    ANSELC = 0x00;
    ANSELB = 0x00;
    ANSELA = 0x00;

    WPUE = 0x00;
    WPUB = 0xFF;
    WPUA = 0xFC;
    WPUC = 0xC1;            // RX TX UART  Alarm RC0
    
    RA0PPS=0;
    RA1PPS=0;
    RA2PPS=0;

    // RxyI2C registers
    // RB1I2C = 0x00;
    // RB2I2C = 0x00;
   
    RB0PPS=0;
    RB1PPS=0;
    RB2PPS=0;
    RB3PPS=0;
    RB4PPS=0;
    RB5PPS=0;
    RB6PPS=0;
    RB7PPS=0;
    // RC3I2C = 0x00;
    // RC4I2C = 0x00;

    // ODx registers
    ODCONA = 0x07;          // 0x07 => open drain sur RA0,RA1,RA2  OWS sensor
    ODCONB = 0x00;
    ODCONC = 0x18;          // I2C 

    // SLRCONx registers
    SLRCONA = 0xFF;
    SLRCONB = 0xFF;         // 0xFF;
    SLRCONC = 0xFF;

    // INLVLx registers
    INLVLA = 0xFF;
    INLVLB = 0xFF;
    INLVLC = 0xFF;
    INLVLE = 0x08;
    
    IOCAF=0;
    IOCAN=0;
    IOCAP=0;

    IOCBF=0;
    IOCBN=0;
    IOCBP=0;
    
    IOCCF=0;
    IOCCN=0;
    IOCCP=0;
    
    RC0PPS =0;
    RC1PPS =0;
    RC2PPS =0;
    RC5PPS=0;               // SW6 input
    RC6PPS=0;
    RC7PPS=0;
    
    Alarm_Inp1_dir=1;       // RC1
    Alarm_Inp2_dir=1;       // RC2
    Alarm_Out_dir=0;        // RC0
    Alarm_Out=0;  
    BP_Egalisation_Dir=1;   // RC5  
           
	// I2C1
    RC3PPS = 0x21;          // RC3->I2C1:SCL1;    
    RC4PPS = 0x22;          // RC4->I2C1:SDA1; 
    // UART1
    RC6PPS = 0x13;          // RC6->UART1:TX1;    
    U1RXPPS = 0x17;         // RC7->UART1:RX1;    
    I2C1SCLPPS = 0x13;      // RC3->I2C1:SCL1;  
    I2C1SDAPPS = 0x14;      // RC4->I2C1:SDA1;     
}

// -------------  I2C --------------------------------

void Init_I2C (void)
{   
    I2C1CLK    = 0x03;      // I2C1 Clock Selection Register, MFINTOSC 500kHz ?? 100kHz ??  // doc p. 581
    // 2-04-2023  probleme maxi pCF SLC =100KHz
    // I2C1CLK = 0x06;      // 0110	 TMR2 post scaled output 42Khz theorique
    // SQA mesure  18.00+11.76=29.76S -> 33.6Khz ?? why ?
    I2C1CON0   = 0x04;      // I2C1 Control Register 0, Master mode, 7-bit Address  // doc p.577
    I2C1CON1   = 0x80;      // I2C1 Control Register 1, Acknowledge value transmitted after received data 
                            // (when I2CCNT=0) : 1 = NACK (Not ACKnowledge) // doc p.579
    I2C1CON2   = 0x00;      // I2C1 Control Register 2, envoi Start non auto, SDAHT 300ns hold time, BFRET 8 i2c clock pulses  // doc p.580
    I2C1CNT    = 0;
    // I2C1CON2bits.FME=1;
    I2C1CON2bits.ABD=0;     // ADB=0; // Transmitted Address data is loaded from the I2CxADB0/1 registers.
    // I2C1ADB1 = 0x3C;     // 0x3C adresse bus I2C mini oled SSD1306
    I2C1ADB1   = 0x20 ;     // LCD_ADDR; // LCD 2x16 avec PCF8754
    I2C1PIRbits.PCIF = 0;   // clear STOP bit flag
    // I2C1CON2bits.ABD=1;   
    I2C1CON0bits.EN=0;      // i2c1 OFF   
}

bool I2C1_DevicePresent(int16_t Address)
{
    I2C1PIRbits.PCIF = 0;           // clear STOP bit flag
    I2C1ADB1 = Address;             // load slave Addr and R/W
    I2C1CNT  = 0;
    I2C1CON0bits.S = 1;             // send START + Addr
    while (I2C1PIRbits.PCIF == 0);  // wait for STOP
    return !I2C1CON1bits.ACKSTAT;
}
 
void Test_Presence_I2C_devices(void)
{
    int i,j;
    txt=&TEXTE[0]; 
    *(txt)=0;
    // U1TXB='1';__delay_ms(20);
    // I2C1CON2 = 0x00; // <- OK
    I2C1CON2bits.ABD=0; // ADB=0; // Transmitted Address data is loaded from the I2CxADB0/1 registers.
    // U1TXB='2'; __delay_ms(20);
    I2C1CON0bits.EN = 1;
    // U1TXB='3'; __delay_ms(20);
    for (i=2; i<252; i=i+2)
    {
        if (I2C1_DevicePresent(i))
        {
            k=i>>1;
            sprintf(txt," @ decimal #%4u  soit @Device 7bits = 0X%02X ",i,k);
            //Print(txt);
            switch (k)
            {
                case 0x20:                              // de base + 7 autres
                case 0x21:
                case 0x22:
                case 0x23:
                    //...etc 
                case 0x27:
                    strcat(txt," PCF8754 for LCD 2x16cars"); 
                    break;
                case 0x28:
                case 0x29:
                case 0x2A:
                    // case etc ..
                    strConstRamCpy(CRam1,"PCF8574 8bits IO" );  
                    j=strlen(txt);
                    strcpy(txt+j,CRam1);
                    //txt=strcat(txt,CRam1);            // de base + 7 autres
                    break;
                case 0x37:
                    strcat(txt,"LCD 2119 2x16cars");    // de base + 7 autres
                    break;
                case 0x38:
                case 0x39:
                case 0x3A:
                case 0x3B:
                    // case etc ..
                    strcat(txt,"PCF8574A 8bits I/O");   // de base + 7 autres
                    break;
                case 0x3C:
                    strcat(txt,"OLED SSD1306");
                    break;
                case 0x57:
                    strcat(txt,"EEPROM 512bytes");
                    break;
                case 0x68:
                    strcat(txt,"RTC DS3231");
                    break;
                case 0xA0:
                    strcat(txt,"Eeprom 24LCxxx 256k ou 512K");
                    break;
                default:
                    strcat(txt,"non recens\E9");
                    break;
            }
            Print(txt);CRLF1();
        }
    }
    I2C1CON0bits.EN = 0;
    // I2C1CON2 = 0x18;
    I2C1CON2bits.ABD=1;
    CRLF1();
}

/*
void Test_Sortie_via_SW0()
{
    if (Etats_BP==SW0 && Duree_Appui>1000) // SW0
    {
        Etats_BP=0;
        Etats_IOCBF=0;
        Restart_Timeout();
        SPas=0;
        MPas=0;
        Menu=0;
        CPrint(" Sortie via SW0>1sec\r\n");
    }
} 
*/

#include "MAJ_RTC_Manuelle_2024-08.inc"

void Terminaison_Menu_Direct()
{
    CPrint("Sortie Menu ");
    PrintChar(Menu+48);
    CRLF1();
    __delay_xSec(1);
    Etats_BP=0;
    IOCBF=0;
    Menu=0;
    Etats_BP=0;
    Drapeaux.Key_ON=0;
    PIR1bits.INT0IF=0;
    PIE1bits.INT0IE=1;
}
      
void  Affiche_Ligne2_Menu10()
{
    LCD_Write_Text_At(2,1,CRam1);
    if(Bavard>0)  Print(CRam1);CRLF1(); 
    __delay_ms(1000);
}   
 
#include "MENU10_1234_2024-08.inc" // menus appels via interrupt SW0
// #include "MENUS_SW4_Programmation_Horaire_2024-04.inc" // menus appels via interrupt SW0

//  ----------------------------------------

// special SW6 
void  Affiche_MENU_Etalonnage_Sondes()
{   
    LCD_Cmd(LCD_CLEAR);  
    // 12345678901234567890
    sprintf(CRam1,"Etalonnage 3 Sondes ");
    Print(CRam1);CRLF1();
    LCD_Write_Text_At(1,1,CRam1);       
}
 
#ifdef With_SMT1
    void SMT1_Init(char Choix_SMT1_Clock)
    { 
        // 04-04-2021
        // registre  SMT1CON0
        SMT1CON0bits.SMT1EN =1;     // SMT enabled
        SMT1CON0bits.WPOL=0;        // Window Polarity
        SMT1CON0bits.SPOL=0;        // Signal Polarity
        SMT1CON0bits.CPOL=0;        // Clock Polarity
        SMT1CON0bits.SMT1PS1=0;     // PS<1:0>: SMT Prescale Select bits = 1/1
        SMT1CON0bits.SMT1PS0=0;     // 11=1/8 ; 10=1/4 ; 01=1/2 ; 00=1/1
        SMT1CON0bits.SMT1EN =1;     // SMT enabled
        SMT1CON0bits.SMT1STP=0;     // 0=reset ; 1=STOP; 
        SMT1CON1bits.SMT1GO=0;      // 1=suit l'entree ; 0=stop suivi
        SMT1CON1bits.SMT1REPEAT=0;  // 0=Single Acquisition ; 1=repeat mode
        // REGISTER 25-4: SMT1CLK: SMT CLOCK SELECTION REGISTER 16MHz
        // 000=FOSC/4 ; 001=FOSC ; 010=HINTOSC 16MHz ; 101=MFINTOSC/16 (32 kHz)
        // 100 = MFINTOSC (500 kHz)
        if (Choix_SMT1_Clock<6) SMT1CLKbits.CSEL=Choix_SMT1_Clock;
        // SMT1CLKbits.CSEL2=  1;   // 31,25Khz => tick=32S
        // SMT1CLKbits.CSEL1=  0;
        // SMT1CLKbits.CSEL0=  1;
        // 25.7.1 PW (Pulse Width) AND PR (Periode Read)  ACQUISITIONI NTERRUPTS
        PIR1bits.SMT1PRAIF=0;
        PIE1bits.SMT1PRAIE=0;
        // 25.7.2  PERIOD MATCHI NTERRUPT
        PIR1bits.SMT1IF=0;
        PIE1bits.SMT1IE=0;
        // init  compteur
        SMT1PRU=0xFF;
        SMT1PRH=0xFF;
        SMT1PRL=0xFF;
        // MODE de fonctionnement TIMER  page 396  
        // 0000=Timer : 0100=windowed measure  1000=counter
        // SMT1CON1=0;
        SMT1CON1bits.MODE3=0;
        SMT1CON1bits.MODE2=0;
        SMT1CON1bits.MODE1=0;
        SMT1CON1bits.MODE0=0;
        SMT1CON0bits.SMT1EN=1;      // SMT enabled
        // SMT1_Measure=0L;
        // ST=&SMT1_Measure;        // pointeur Byte sur debut entier long 32 bits
    }
#endif

void print_hex_32( uint32_t value )
{
    signed char nibble;
    char msg[2];
    char c;
    msg[1] = '\0';
    for (nibble = 7; nibble >= 0; nibble--)
    {
        c = value >> (nibble * 4);
        c = c & 0x0F;
        if (c < 10)
        {
            msg[0] = 0x30 + c;
	    }
        else
        {
            msg[0] = 'A' + c - 10;
        } 
        Print( msg );
    }
    return;
}

void Affiche_3_mesures_DS18B20_sur_LCD(char Avec_Corr)
{   
    Erase_Line(1);
    if (Avec_Corr==0)
    {  
        CPrint(" Mesures 3 temperatures brutes :\r\n");    
        LCD_putsRom("3 Mes.DS18B20 Brutes");
    }   
    else        // 12345678901234567890
    {    
        LCD_putsRom("3 Mesures corrigees ");  
        CPrint(" Mesures 3 temperatures Corrigees :\r\n");
    } 
    Erase_Line(2);
                // 12345678901234567890
    LCD_putsRom("T1.INT.             ");
    INT_mes= getTemperature1();
    
    Erase_Line(3);
    EXT_mes= getTemperature2(); 
               // 12345678901234567890
    LCD_putsRom("T2.EXT.             "); 
    
    Erase_Line(4);
    LCD_putsRom("T3.EAU.             ");  
    EAU_mes= getTemperature3();
    
    i=0;
    
    if (Avec_Corr>0)  INT_mes=INT_mes+Txcor[0];
    sprintf(txt," INT_mes= %5.3f%cC",INT_mes,176);
    Print(txt); CRLF1();
    sprintf(CRam1,"%3.2f C ",INT_mes);
    LCD_Write_Text_At(2,12,CRam1);
    LCD_Chr_At(2,17,7);     // degre C
    
    if (Avec_Corr>0)  EXT_mes=EXT_mes+Txcor[1];
    sprintf(txt," EXT_mes= %5.3f%cC",EXT_mes,176);
    Print(txt); CRLF1();
    sprintf(CRam1,"%3.2f C ",EXT_mes);
    LCD_Write_Text_At(3,12,CRam1);
    LCD_Chr_At(3,17,7);   // degre C
    EAU_mes= getTemperature3();
    
    if (Avec_Corr>0)  EAU_mes=EAU_mes+Txcor[2];
    sprintf(txt," EAU_mes = %5.3f%cC",EAU_mes,176);
    Print(txt); CRLF1();
    sprintf(CRam1,"%3.2f C",EAU_mes);
    LCD_Write_Text_At(4,12,CRam1);
    LCD_Chr_At(4,17,7);   // degre C
}

void Sauve_Parametres_en_Eeprom(uint16_t Where)    
{
    int i;
    if ((Where==Org_Sauve_Param_Travail) || (Where==Org_Sauve_Param_Usine))
    {
        // if ( (Bavard & 0x01)==1 )
        // {
            sprintf(CRam1," \r\n Sauve Parametres en %4X soit %d \r\n",Where,Where);
            Print(CRam1);
        // }
        Sauve_Float_To_Eeprom(	Where+  0 ,	CHD_min	);			
        Sauve_Float_To_Eeprom(	Where+  4 , CHD_max	);			
        Sauve_Float_To_Eeprom(	Where+  8 , EXT_min	);			
        Sauve_Float_To_Eeprom(	Where+ 12 , INT_cor	);			
        Sauve_Float_To_Eeprom(	Where+ 16 , NRG_cor	);
        Sauve_Float_To_Eeprom(	Where+ 20 , CFT_csg	);			
        Sauve_Float_To_Eeprom(	Where+ 24 ,	ECO_csg	);			
        Sauve_Float_To_Eeprom(	Where+ 28 ,	HGL_csg	);			
        Sauve_Float_To_Eeprom(	Where+ 32 ,	HYS_int	);			
        Sauve_Float_To_Eeprom(	Where+ 36 ,	HYS_ext	);			
        Sauve_Float_To_Eeprom(	Where+ 40 ,	HYS_eau	);	
     // 07-09-2024 
        Sauve_Float_To_Eeprom(	Where+ 44 ,	CSG_En_Cours);	
        for (i=0;i<8;i++) DATAEE_WriteByte (Where+ 48+i,0);	   // 2 reserves FLT  ou 8 bytes  
        for (i=0;i<8;i++) DATAEE_WriteByte (Where+ 56+i,Affectation_Hebdo[i]);
        DATAEE_WriteByte (Where+ 64,Progr_En_Cours);
        DATAEE_WriteByte (Where+ 65,NRG_ind);
        DATAEE_WriteByte (Where+ 66 ,Forcage_Mode);
        DATAEE_WriteByte (Where+ 67,Forcage_Consigne);
        DATAEE_WriteByte (Where+ 68 ,Alarmes);
        DATAEE_WriteByte (Where+ 69 ,Etat_Alarme);
        DATAEE_WriteByte (Where+ 70 ,Choix_Hors_Gel);
        DATAEE_WriteByte (Where+ 71 ,Controle_Chaudiere);
    }
    else
    {   
        sprintf(CRam1," \r\n Erreur Sauve Parametres en %4X soit %d \r\n",Where,Where);
        Print(CRam1);
    } 
    // last adress= 541+8=62
}  
 
 void Rafraichit_LCD_Table_en_cours(char Table)
 {  // rev 21-08-2024
    int i;
    if ( (Bavard & 0x01)==1 )
    {
        CPrint("Prog en cours :"); PrintChar(Table+48);PrintChar(9);PrintChar(Progr_Name[Table]);
    }     
    sprintf(CRam1,"%c%c:%c%c m             ",time[0],time[1],time[3],time[4]);
    for (i=0;i<12;i++) *(CRam1+8+i)= Tables_Programmations_Horaires[Table][i];
    for (i=1;i<21;i++) LCD_Chr_At( 3,i,*(CRam1+i-1) );
    sprintf(CRam1,"%1c %c%c am             ",Progr_Name[Table],*(All_Jour_Semaine+jS*2),*(All_Jour_Semaine+jS*2 +1 ) );
    for (i=0;i<12;i++) *(CRam1+8+i)= Tables_Programmations_Horaires[Table][i+12];
    for (i=1;i<21;i++) LCD_Chr_At( 4,i,*(CRam1+i-1) );
 }
   

//-------------------------------- Autre Calcul --------------------------------
void  Calcul_Consigne_Eau_Chaudiere()
{
    // Variables pour calculs intermdiaires
    float Fct1;  // ces variables ne sont utilises que dans cette fonction
    float Dif0;
    float Dif1;
    float Dif2;
    float Dif3;
    float Dif4;
    float Dif5;
    float Dif6;
    float F0=0.00;
    
    //--------------------------------------------------------------------------
    //------------ Calcul de la Pente de la courbe de chauffe ------------------
    switch (CHX_mod)        // => Selon choix mode (confort en exemple)
    {
        case 1 :    // En Mode CONFORT actif ( Forage ? ) 
            // U1TXB='*';   // echo sur terminal pour traage programme
            // Mode confort (choisi en exemple pour CHX_mod = CFT_mod)
            // Si CHD_max - (CHD_cor - CSG_En_Cours) >= CHD_max
            // Alors : Pente = (EXT_min - INT_cbl) / (CHD_max - EAU_min)
            // Sinon : Pente = (EXT_min - INT_cbl) / (CHD_max - EAU_min - (CHD_cor - CSG_En_Cours))
            // Calcul du terme INT_cbl en Mode Confort
            INT_cbl = CSG_En_Cours + INT_cor;   // was CFT_csg
            // Calcul du terme EAU_min pour mode confort
            if ( (INT_cbl + 1) <= CHD_min ) // => Condition en regard de CHD_min
            {
                EAU_min = CHD_min;          // => RESULTAT_1 EAU_min
            }
            else                            // => Sinon
            {
                EAU_min = INT_cbl + 1;      // => RESULTAT_2 EAU_min
            }
            Dif0 = CHD_cor - CSG_En_Cours;  // Calcul intermediaire Dif0
            Dif1 = CHD_max - EAU_min;       // Calcul intermediaire Dif1
            Dif2 = Dif1 - Dif0;             // Calcul intermediaire Dif2
            Dif3 = CHD_max - Dif0;          // Calcul intermediaire Dif3        
            break ;
        case 2 :    // En Mode ECO actif ( Forage ? )    
            // U1TXB='#'; // echo sur terminal pour traage programme
            // Mode eco (hors exemple, pour CHX_mod=ECO_mod)
            // Si CHD_max -(CHD_cor - CSG_En_Coursg)>= CHD_max
            // Alors : Pente = (EXT_min - INT_cbl) / (CHD_max - EAU_min)
            // Sinon : Pente = (EXT_min - INT_cbl) / (CHD_max - EAU_min - (CHD_cor - CSG_En_Cours))
            INT_cbl = CSG_En_Cours + INT_cor;
            EAU_min;
            if ( (INT_cbl + 1) <= CHD_min )
            {
                EAU_min = CHD_min;
            }
            else
            {
                 EAU_min = INT_cbl + 1;
            }
            Dif0 = CHD_cor - CSG_En_Cours;
            Dif1 = CHD_max - EAU_min;
            Dif2 = Dif1 - Dif0;
            Dif3 = CHD_max - Dif0;
            break ;
        default :   // En Mode HORS GEL actif
            // U1TXB='?'; // echo sur terminal pour traage programme
            // echo// Mode hors gel (hors exemple, pour CHX_mod = HGL_mod)
            // Si CHD_max - (CHD_cor - HGL_csg) >= CHD_max
            // Alors : Pente = (EXT_min - INT_cbl) / (CHD_max - EAU_min)
            // Sinon : Pente = (EXT_min - INT_cbl) / (CHD_max - EAU_min - (CHD_cor - HGL_csg))
            INT_cbl = HGL_csg;
            EAU_min;
            if ( (INT_cbl + 1) <= CHD_min )
            {
                EAU_min = CHD_min;
            }
            else
            {
                EAU_min = INT_cbl + 1;
            }
            Dif0 = CHD_cor - HGL_csg;
            Dif1 = CHD_max - EAU_min;
            Dif2 = Dif1 - Dif0;
            Dif3 = CHD_max - Dif0;
            break ;
    }
    Dif4 = EXT_min-INT_cbl;         // Calcul intermediaire Dif4    
    if (Dif3 >= CHD_max)            // => Condition en regard de CHD_max : Si CHD_max - (CHD_cor - XXX_csg) >= CHD_max
    {
        Pente = Dif4 / Dif1;        // => RESULTAT_1 Pente = (EXT_min - INT_cbl) / (CHD_max - EAU_min)
    }
    else                            // => Sinon :
    {
        Pente = Dif4 / Dif2;       // => RESULTAT_2 Pente = (EXT_min - INT_cbl) / (CHD_max - EAU_min - (CHD_cor - XXX_csg))
    }

    //--------------------------------------------------------------------------
    //----------- Calcul de Offset de la courbe de chauffe ---------------------
    Fct1 = Pente * EAU_min;         // Calcul intermediaire Fct1
    Dif5 = Fct1 - INT_cbl;          // Calcul intermediaire Dif5
    Offset = - Dif5;                // => RESULTAT OFFSET
    //--------------------------------------------------------------------------
    // Calcul de la temperature de consigne de l'eau de la chaudiere )
    Dif6 = EXT_mes - Offset;        // Calcul intermediaire Fct1
    F1= Dif6 / Pente;
    if (F1 >= EAU_max)              // => Condition_1
    {
         EAU_cbl = EAU_max;         // => RESULTAT_1 
    }
    else
    {  
        if (F1 <= EAU_min)          // => Condition_2 en regard de EAU_min
        {   
            EAU_cbl = EAU_min;      // => RESULTAT_2 
        }
        else                        // => Condition_3
        {
            EAU_cbl = round( F1 );  // => RESULTAT_3 EAU_cbl  Arrondi au degre C
        }        
    }
    //--------------------------- Affichage YAT --------------------------------
    if(Bavard==9) 
    {
        sprintf(txt,"INT_cbl= %3.2f \r\n",INT_cbl);
        Print(txt);
        sprintf(txt," Dif0=%3.3f  Dif1=%3.3f Dif2=%3.3f Dif3=%3.2f\r\n Dif4=%3.2f  Dif5=%3.2f Dif6%3.2f\r\nEAU_min=%3.2f EAU_max %3.2f \r\n",Dif0,Dif1,Dif2,Dif3,Dif4,Dif5,Dif6,EAU_min,EAU_max);
        Print(txt);
    }
}

void Affiche_Plages_Programme_Horaire(uint8_t jx)
{  
    int i ;
    uint8_t Prg;
    Prg=jx;
    char TEXTUEL[10];
    LCD_Cmd(LCD_CLEAR);__delay_ms(100);
    strConstRamCpy(TEXTUEL,"         ");
    TEXTUEL[0]=0;
    strncpy(CRam1,&Tables_Programmations_Horaires[Prg][24],8);
    LCD_Write_Text_At(1,1,CRam1);
    CPrint(" Decodage Table #"); 
    PrintChar(Prg+48); PrintChar(':');Print(CRam1);CRLF1();
    // affiche table de programmation en cours sur LCD
    // LCD_Write_CText_At(3,1,"Matin");
    LCD_Chr_At(3,7,'M');            // 27-03-2024
    for (i=0;i<12;i++)  LCD_Chr_At( 3,9+i, Tables_Programmations_Horaires[Prg][i]);
    // LCD_Write_CText_At(4,1,"A.Midi");
    LCD_Write_CText_At(4,6,"AM");   // 27-03-2024
    for (i=0;i<12;i++) LCD_Chr_At( 4,9+i,Tables_Programmations_Horaires[Prg][i+12]);
    k=0;
    i=0;
    Plage=0;
    txt=&TEXTUEL[0];  
    Erase_Line(2);
    i=0;
    do
    {    
        Deb=Tables_Programmations_Horaires[Prg][i];
        do
        {
            i++;
            Deb=Tables_Programmations_Horaires[Progr_En_Cours][i];
        } 
        while ( (i<23) && (Deb==OldDeb) ) ;
        TEXTE[0]=32; 
        // if(Deb==0) TEXTE[0]='(';  // supprim 27-03-2024
        // if (Deb==3) TEXTE[0]='*'; // supprim 27-03-2024
        TEXTE[1]= (i/10)+48;
        TEXTE[2]= (i%10)+48;
        TEXTE[3]='h';
        Plage++;
        TEXTE[4]=0;
        switch (Plage) // renseigne la plage au bon endroit !
        {
            case 1: 
                if (Bavard==10)
                {
                    CPrint("\tPlage 1H :");
                    Print( TEXTE); CRLF1();
                }
                LCD_Write_Text_At(1,9,TEXTE);
                break;
            case 2:
                if (Bavard==10)
                {
                   CPrint("\tPlage 1B :");
                   Print( TEXTE); CRLF1();
                }
                    LCD_Write_Text_At(2,9,TEXTE);
                    break;
            case 3:
                if (Bavard==10)
                {
                    CPrint("\tPlage 2H :");
                    Print( TEXTE); CRLF1();
                }
                LCD_Write_Text_At(1,13,TEXTE);
                break;
            case 4:
                if (Bavard==10)
                {
                    CPrint("\tPlage 2B :");
                    Print( TEXTE); CRLF1();
                }
                  LCD_Write_Text_At(2,13,TEXTE);
                break;
            case 5:
                LCD_Write_Text_At(1,17,TEXTE);
                if (Bavard==10)
                {
                    CPrint("\tPlage 3H :");
                    Print( TEXTE); CRLF1();
                }
                break;
            case 6:
                LCD_Write_Text_At(2,17,TEXTE);
                if (Bavard==10)
                {
                    CPrint("\tPlage 3B :");
                    Print( TEXTE); CRLF1();
                }
                break;
            default:
                break;
        }
        OldDeb=Deb;
        i++;
        __delay_ms(20);  // 09-05-2024  was 200
    }
    while(i<23);       
}

#include "MENU4_SW4_2024-0918.inc"



void Charge_Progr_Travail(void)
{
// rappel: Org_Sauve_Progr_Travail= 0x00A0 ;      //160
    static uint16_t  i,j,k;
    static char cx=0;
      CRLF1();
        for (i=0;i<10;i++)
        {  PrintChar(i+48);PrintChar('>');
            for (j=0;j<24;j++)  
            {  
                k=Org_Sauve_Progr_Travail + i*32 +j;
                cx=DATAEE_ReadByte(k);
                Tables_Programmations_Horaires[i][j]=cx;
               PrintChar(cx+48);
            }
            PrintChar(' ');
            k++;
            cx=DATAEE_ReadByte(k);
            PrintChar(cx);
            CRLF1();
        }
}



void Charge_Param_Travail (uint16_t ad)
{
   static uint16_t k1;
    k1= ad;      
    if ( ( Org_Sauve_Param_Travail==k1) || (Org_Sauve_Param_Usine==k1) )
    {
        Bavard=20; 
        sprintf(CRam1," Restitue Parametres Flt depuis @ %04X soit %d    Bavard=%d\r\n",k1,k1,Bavard);
        Print(CRam1);
    
        CHD_min =       Read_Float_from_Eeprom( k1 +  0);		
        CHD_max =       Read_Float_from_Eeprom( k1 +  4);			
        EXT_min =       Read_Float_from_Eeprom( k1 +  8);			
        INT_cor =       Read_Float_from_Eeprom( k1 + 12);			
        NRG_cor =       Read_Float_from_Eeprom( k1 + 16);
        CFT_csg =       Read_Float_from_Eeprom( k1 + 20);			
        ECO_csg =       Read_Float_from_Eeprom( k1 + 24);			
        HGL_csg =       Read_Float_from_Eeprom( k1 + 28);			
        HYS_int =       Read_Float_from_Eeprom( k1 + 32);			
        HYS_ext =       Read_Float_from_Eeprom( k1 + 36);			
        HYS_eau =       Read_Float_from_Eeprom( k1 + 40);	
        CSG_En_Cours =  Read_Float_from_Eeprom( k1 + 44);
       //  reserve float en 48
        // reserve float en 52   
        Bavard=22; 	
        sprintf(CRam1," Restitue Parametres Bytes depuis @ %04X soit %d    Bavard=%d\r\n",k1+56,k1+56,Bavard);
        Print(CRam1);
        for (i=0;i<8;i++)
        {
            Affectation_Hebdo[i]=DATAEE_ReadByte (k1 + 56 +i);
        }
        Progr_En_Cours  = DATAEE_ReadByte ( k1 + 64);	   
        NRG_ind         = DATAEE_ReadByte ( k1 + 65); 
        Forcage_Mode    = DATAEE_ReadByte ( k1 + 66);
        Forcage_Consigne= DATAEE_ReadByte ( k1 + 67);
        Alarmes         = DATAEE_ReadByte ( k1 + 68);
        Etat_Alarme     = DATAEE_ReadByte ( k1 + 69);
        Choix_Hors_Gel      = DATAEE_ReadByte ( k1 + 70);
        Controle_Chaudiere  = DATAEE_ReadByte ( k1 + 71);
        Bavard=0;
        CPrint("... Fin de recup Eeprom data ( until offet +71) -> ");
        if ( Org_Sauve_Param_Travail == k1)  CPrint(" RAM zone Param Travail\r\n"); 
        if ( Org_Sauve_Param_Usine == k1)  CPrint(" RAM zone Param USINE\r\n"); 
    }
    else
    {   
      sprintf(CRam1," Erreur adresse Eeprom : %04X soit %d \r\n",k1,k1);
      Print(CRam1);
    }  
}  
     



void main(void)
{
    OSCCON1 = 0x60;
    OSCCON3 = 0x00;
    OSCEN   = 0x00;
    OSCFRQ  = 0x08;      // 64Mhz
    OSCTUNE = 0x00;
    __delay_ms(500);
     
    GIE=0;  
   
    IOCAP=0;
    IOCAN=0;
    IOCAF=0;
    IOCCP=0;
    IOCCN=0;
    IOCCF=0;
//    
    IOCBP   = 0x00;     // rising edge off
    // IOCBN   = 0x7E;  // falling edge B6,B5,B4,B3, B2, B1 sauf B0 et B7
    IOCBN   = 0x00;     // falling edge OFF
    PIE0bits.IOCIE=0;   // invalide toutes interrup IOC
   
    INT0EDG = 0;        // falling edge int0 B0
    PIE1bits.INT0IE=0;
    PIR0bits.IOCIF=0;
 
    PIR1bits.INT0IF=0; 
    Drapeaux.Key_ON=0;
   
    Hardware_Init();
    
    U1TXB='@';
        
    for (i=0;i<sizeof(TEXTE);i++) TEXTE[i]=0;
    for (i=0;i<sizeof(Buffer1);i++) Buffer1[i]=0;
    for (i=0;i<sizeof(CRam1)-1;i++) CRam1[i]=0;
    for (i=0;i<sizeof(Ram_Menus10)-1;i++) Ram_Menus10[i]=0;

    for (i=0;i<9;i++) tmp[i]=0;
    txt=&TEXTE[0]; 
  
    Duree_Appui=0;
    #ifdef With_SMT1
        SMT1_Measure=0L;
        ST=(char *) &SMT1_Measure;
    #endif
    Forcage_Mode=0;
    Forcage_Consigne=0;
    Controle_Chaudiere=ON;
    Flag_Eeprom=0;
          
    UART1_Init();
    __delay_ms(500);
    CRLF1();
    
    
     CPrint(" Test SW6 pour demande Egalisation ou Restauration Usine\r\n");  
    // ---------------- test si demande equalisation---------------------
    Demande_Equalisation=0;  
    Duree_Appui=0;
    U1TXB='&';
    // while ( (PORTC & 0x20)>>5==0 )



    while( (SW6==0) && (Duree_Appui<100) )   // 10sec max
    {    
        __delay_ms(100);
        if (Duree_Appui %5==0) __asm("btg LATA,6"); // led vert 
        PrintChar('.');
        Duree_Appui++;
    } 
    sprintf(txt," Duree Appui : %5d",Duree_Appui);
    Print(txt);CRLF1();

      // ---------------------------  
    // test pour differencier les demandes Egalisation ou  Restauration Usine
    if ( (Duree_Appui>20) && (Duree_Appui<50) )   // 2sec  5sec
    {
        U1TXB='E';      // pour differencier l'action sur SW6
        Demande_Equalisation=1;
       LED_vert=ON;     // feu fixe eteint  (car ma led est tire au +VCC !!!)
    }  
    Demande_Restauration_Param_Usine=0;
    if (  (Duree_Appui>50)  && (Duree_Appui<80) ) // 5  8sec
    {  
        U1TXB='R';      // pour differencier l'action sur SW6
        Demande_Restauration_Param_Usine=1;
        LED_vert=ON;    // feu fixe eteint  (car ma led est tire au +VCC !!!)
    } 
    Duree_Appui=0;
    
    CPrint(" Presentation :\r\n");       
    for (i=0;i<9;i++)   
    {
        CPrint(Messages[i]);
    }
    CRLF1();
   
    sprintf(txt," Compiled %s at %s UTC  version XC8 :%d \r\n", __DATE__, __TIME__,__XC8_VERSION);
    Print(txt);
    CRLF1();
        
 
    
    if (Demande_Equalisation==1)
    {
        CPrint("\r\n --- Demande d'Equalisation  active ---- \r\n");
        CRLF1();
    }  
    if (Demande_Restauration_Param_Usine==1)
    {
        CPrint("\r\n --- Demande de Restauration  active ---- \r\n");
        CRLF1();
    }  
    // https://www.fantaspic.fr/viewtopic.php?style=4&f=10&t=1308&start=10
    // pre_chargement Eeprom PIC 18F27K42
 
    //----------  test si 1er demarrrage du code  programme---------------------------
    cx= DATAEE_ReadByte(0x0000);
     // forage version Progr
        strConstRamCpy(CRam1,VERSION);  
        DATAEE_WriteByte(1,*(CRam1+0));
        DATAEE_WriteByte(2,*(CRam1+1));
        DATAEE_WriteByte(3,*(CRam1+2));
        DATAEE_WriteByte(4,*(CRam1+3));
        DATAEE_WriteByte(5,*(CRam1+4));
        DATAEE_WriteByte(6,*(CRam1+5));
        DATAEE_WriteByte(7,0);
    if (cx !=99)
    { 
        // version Progr
         strConstRamCpy(CRam1,VERSION);  
        DATAEE_WriteByte(1,*(CRam1+0));
        DATAEE_WriteByte(2,*(CRam1+1));
        DATAEE_WriteByte(3,*(CRam1+2));
        DATAEE_WriteByte(4,*(CRam1+3));
        DATAEE_WriteByte(5,*(CRam1+4));
        DATAEE_WriteByte(6,*(CRam1+5));
        DATAEE_WriteByte(7,0);
        
              
       // supprim 04/10/2024
      //  for (i=0;i<8;i++) Affectation_Hebdo[i]=0;
        
        CPrint("1ere init des 10 Tables Prg Horaire en Eeprom PIC at 0x100\r\n");
        CPrint(" car Flag Run Once=0, force ensuite a 99\r\n");
          // sauve Tables Progr  simultanment dans l'espace  Travail et Usine
        for (i=0;i<10;i++)
        { 
            for (j=0;j<24;j++)  
            {  
                k=Org_Sauve_Progr_Travail + i*32 +j;
                cx=Tables_Programmations_Horaires[i][j];
                DATAEE_WriteByte(k,cx);
                //__delay_ms(25);  
                PrintChar(cx+48);
                k=Org_Sauve_Progr_Usine + i*32 +j;      // table usine
                DATAEE_WriteByte(k,cx);
                //__delay_ms(25);
            }
             PrintChar(32); PrintChar(32);
            for (j=24;j<32;j++)  
            {  
                k=Org_Sauve_Progr_Travail + i*32 +j;
                cx=Tables_Programmations_Horaires[i][j];
                DATAEE_WriteByte(k,cx);
                //__delay_ms(25);  
                PrintChar(cx);
                k=Org_Sauve_Progr_Usine + i*32 +j;      // table usine
                DATAEE_WriteByte(k,cx);
                //__delay_ms(25);
            }
            CRLF1();
        }
          
        Sauve_Parametres_en_Eeprom(Org_Sauve_Param_Travail );   // zone 0x0050  0x160 
        Sauve_Parametres_en_Eeprom(Org_Sauve_Param_Usine);// zone 320 bytes
        
        // rajout ? ou pas ? 04-10-2024
        Sauve_Corrections_Temper();
        
        CPrint("Fin de sauvegarde en eeprom\r\n");    
        DATAEE_WriteByte(0x0000,99);__delay_ms(25);
    }  
      
    CPrint(" Recuperation des parametres de travail depuis Eeprom \r\n");  
    Charge_Param_Travail( Org_Sauve_Param_Travail );
    CPrint(" \r\nRecuperation des Programmes de travail depuis Eeprom \r\n");  
    Charge_Progr_Travail( ); // par defaut Org_Sauve_Progr_Travail= 0x00A0 ;      //160 );
   
    CPrint("Affectation_Hebdo\r\n");
    for (i=0;i<8;i++)
    {
       sprintf(CRam1," i=%d Affectation Hebdo du %s  =%d\r\n",i,JourSemaine[i],Affectation_Hebdo[i]);
       Print(CRam1);
    }
    CRLF1();
    

    #ifdef Prototype
        CPrint (" Hardware: version Prototype : LCD Bleu  l'adresse 0x27 !\r\n");
    #else
        CPrint ("\r\n Hardware: version Carte PCB chaudiere : LCD Blanc a l'adresse 0x20 !\r\n");
    #endif
            
    CPrint(" Init_I2C() 100Khz;\r\n");
    Init_I2C(); // SCLK=  500Khz / 5 = 100Khz
    CPrint(" Test presence devices sur Bus I2C1\r\n");
    Test_Presence_I2C_devices();
    CRLF1();
    CPrint(" #1 Active sortie RTC SQW=1Hz: \r\n");
    CPrint(" GO\r\n");
    // set SQW output  Start oscillateur
    tmp[0]=0x40; // data 
    I2C1_Write1ByteRegister(DS3231_ADDR,0x0E, tmp[0]);
    CPrint(" ok\r\n");
    __delay_ms(100);
 
       // affiche Date Jour Time Complet
    Display_Date_Time(2);  //24-10-2023
    __delay_ms(100);
    
    CPrint(" Temperature DS3231 => ");
    Ds3231_Temp_CP(0);
    Print(DS_Temp);
    CRLF1();
   
    Addr=LCD_ADDR; 
    NbCarPL=20;         // LCD 4x20 !
    sprintf(CRam1," adresse LCD= %d soit 0X%02X \r\n",Addr,Addr);
    Print(CRam1);
    I2C1CON2bits.ABD=1;
    
    CPrint(" \r\nSequence d'Init LCD 4x20 via I2C1 PCF8574\r\n");
    I2C1CON0bits.EN=1;   
    LCD_init(); 
    CRLF1();
    LCD_Cmd(LCD_CLEAR); // 0x01
         
    #ifdef Affiche_tous_les_chars_LCD
        #include "Test_all_char_LCD_2023-0901.inc"
    #endif
   
    #ifdef Prototype
        LCD_Write_CText_At(1,1,"Version Prototype !");
    #else
        LCD_Write_CText_At(1,1,"Version Carte PCB  !");    
    #endif
    __delay_xSec(2); 
    LCD_Cmd(LCD_CLEAR); // 0x01
    LCD_Cmd(LCD_HOME);  // 0x02
    __delay_ms(100); 
 
  
    CPrint(" Chargement caracteres Speciaux  en CGRAM\r\n");
    LCD_putsRom("Caracteres Speciaux ");
    LCD_Load_Custom_Chars(0);  // parametre:  0=mode silence,  1=bavard
    for (i=0;i<8;i++) 
    {
        CPrint(Special_Name1[i]); CRLF1();
        LCD_Chr_At(2,i+1,i);  
    }
    __delay_xSec(1); 

    CRLF1();
    CPrint(" Config et Init One Wire\r\n");
    onewireInit_X();
    __delay_ms(250);
    
    CPrint("1ere serie Mesures brutes\r\n");   
    F1= getTemperature1();  
    sprintf(txt," T1B.INT.  = %5.3f%cC",F1,176);
    Print(txt);CRLF1();
    F2= getTemperature2();
    sprintf(txt," T2B.EXT.  = %5.3f%cC",F2,176);
    Print(txt);CRLF1();
    F3= getTemperature3();
    sprintf(txt," T3B.EAU  .= %5.3f%cC",F3,176);
    Print(txt);CRLF1();
    __delay_xSec(1);  
    
    // --- excution demande egalisation ---------------------------------
    if (Demande_Equalisation==1) 
    {
        CPrint("\r\n  TRAITEMENT demande equalisation \r\n");
        Equalisation_3_DS18B20(); // programme bloqu dans ce processus!
    }
    CRLF1();  
    //------------------------------------------------------------------------    
    CPrint(" Rechargement corrections capteurs DS18B20 depuis Eeprom\r\n");
    Restitue_Corrections_Temper();
    sprintf(CRam1," T1Cor= %5.3f\r\n",Txcor[0] );
    Print(CRam1);     
    sprintf(CRam1," T2Cor= %5.3f\r\n",Txcor[1] );
    Print(CRam1);  
    sprintf(CRam1," T3Cor= %5.3f\r\n",Txcor[2] );
    Print(CRam1);   
    CRLF1(); 
    Affiche_3_mesures_DS18B20_sur_LCD(1);    // param 1 = affiche mesures corrigees
    __delay_xSec(2); 
     
    #ifdef With_SMT1    
        CPrint("\r\n Init Compteur 24 bits SMT1, avec choix clock 4=> 500KHz  tick=2uS\r\n");
        // 0=FOSC/4  1=FOSC  2=HINTOSC 16MHz   4= MFINTOSC (500 kHz ) 5=MFINTOSC/16 (31.25kHz) 
        SMT1_Init(4);  // 500Khz
        START_SMT1
        // __delay_ms(100);
        __delay_xSec(2);
        STOP_SMT1
    
        L1=SMT1_Measure; 
        L2=L1<<1;    //  500Khz tick=2S => multiplie par 2   ,  31,25KHz L1>>5 par 32
        sprintf(txt," Test SMT1 avec __delay_xSec(2) , Nb Tics %lu L2=%lu uS\r\n",L1,L2);
        Print(txt);
    #endif   
    
    Menu=0; MPas=0;
    //SMenu=0;
    SPas=0;
    Etats_BP=0;
  
    CPrint(" Arme interruptions \r\n");
    Vectored_Interrupts_Init();
    PIE0bits.IOCIE=0;
    // IOCEN=10;        // invalide toutes interrup IOC
    IOCEN=0;            // invalide toutes interrup IOC
    IOCBP=0x00;         // pas de detection front Montants sur PORTB 
    IOCBN=0x7E;         // detection front descendant (Negatif)  sauf RB7 et RB0;
    // IOCBN=0;         // detection front descendant (Negatif)  sauf RB7 et RB0;
    IOCBF=0;            // RAZ flag etat pins IOC PORTB
    PIR0bits.IOCIF=0;
    Drapeaux.Key_ON=0;  // raz flag detection interrupt INT0
    PIR1bits.INT0IF=0;  // RAZ flag detection interrupt INT0
    PIE1bits.INT0IE=1;  // autorisee interrupt INT0 sur front descendant pin RB0
    INTCON0bits.GIE=1;  // autorise Toutes les interruptions ( + dont l'UART RX !)
    
    if (Demande_Restauration_Param_Usine==1)
    {
        CPrint(" Restauration de la copie Usine Tables Prg Horaire en Eeprom PIC at 0x0260\r\n");
        CPrint(" dans la Table de Travai et dans la Zone Eprom de travail\r\n");
        LCD_Cmd(LCD_CLEAR);__delay_ms(100);
        LCD_Write_CText_At(1,1,"! Reinitialisation !");
        LCD_Write_CText_At(2,1,"! Parametres USINE !");
        Erase_Line(3);  __delay_ms(100);
        for (i=0;i<10;i++)
        {   // "12345678901234567890"
            sprintf(CRam1," Table #%3d prgr: %c ", i,Progr_Name[i] );
            Print(CRam1);CRLF1();
            LCD_Write_Text_At(3,1,CRam1);
            for (j=0;j<32;j++)
            {  
                k=Org_Sauve_Progr_Usine+ i*32 +j;
                cx=DATAEE_ReadByte(k);
                //__delay_ms(25);
                k=Org_Sauve_Progr_Travail + i*32 +j;
                DATAEE_WriteByte(k,cx);
                //__delay_ms(25);
            }
        }
        CRLF1();
        // raz TCorr
        for (i=0;i<3;i++)
        {     
            F0=0.0;
            Txcor[i]=0.0;
            Sauve_Float_To_Eeprom(Org_Txcor+i*4,F0);
        } 
        LCD_Write_CText_At(1,1," FIN de restauration");
        LCD_Write_CText_At(2,1,"Nouvelle EGALISATION");
        LCD_Write_CText_At(3,1," des sondes Requise ");
        LCD_Write_CText_At(4,1,"  Attente BP Reset  ");
        CPrint("\r\n..fin de restauration\r\n");
        do
        {
            __asm("btg LATA,4");  // LED_rouge  
            __delay_ms(100);
        }
        while(1);
    }   
    CRLF1();
  
    CPrint("\r\n Lecture table programmes horaire en eeprom\r\n");  
   // Lecture_Eeprom_Table_Programmes_Horaires(Bavard & 0x0001); // parametre : 1 = avec visu
    Lecture_Eeprom_Table_Programmes_Horaires(0); // parametre : 0  ..was 1 avec visu  03/10/2024
    Rafraichit_LCD_Table_en_cours(Progr_En_Cours);
    CRLF1();  
    Valeur_Progr= Table_Progr_Horaire_utilisee[Hour];
    Affiche_LCD_Repos();
    __delay_xSec(1);
    CPrint("Init Timer 4 0.5sec\r\n") ;
    Init_Timer4();
    CRLF1();    
   
//  #define TEST_Clignte_Leds    
#ifdef TEST_Clignte_Leds 
#include "Test_CLI05_CLI10_2024-09.inc"
#endif
    
    T4CONbits.T4ON=1;  
    INTCON0bits.GIE=1;//     
    #ifdef With_SMT1
        START_SMT1
        U1TXB='D';
        CRLF1();
        __delay_ms(100);
        STOP_SMT1
        U1TXB='F';__delay_ms(10);
        L1=SMT1_Measure; 
        L2=L1<<1;   //  500Khz tick=2S => multiplie par 2   ,  31,25KHz L1>>5 par 32
        sprintf(txt," Test SMT1 avec U1TXB='D' + CRLF1()+100mS  L2=%lu uS\r\n",L2);
        Print(txt);     
         CRLF1();
    #endif         

    CRLF1();
    CPrint(" Init et test Timer6  N=0 \r\n Start\r\n");
    TMR6_Init_500ms(0);  // 0.5s
    do
    {}
    while (Drapeaux.Tmr6_Elapsed==0);
    Drapeaux.Tmr6_Elapsed=0;
    CPrint(" Stop\r\n") ;   // permet de mesurer la dure avec YAT Stamp time
     
    CPrint(" Init et test Timer6   8 x 500mS \r\n Start\r\n");
    TMR6_Init_500ms(8);     // 8x0.5=> 4sec
    do
    {}
    while (Drapeaux.Tmr6_Elapsed==0);
    Drapeaux.Tmr6_Elapsed=0;
    CPrint(" Stop\r\n") ;   // permet de mesurer la dure avec YAT Stamp time
    Init_Timer2(); // tick=100mS * Cpt2 
    CPrint(" Init Timer2 100mS \r\n");     
       
    // evaluation de la duree fonction   Affiche_LCD_Repos()  
    #ifdef With_SMT1   
        START_SMT1
        Affiche_LCD_Repos();     
        STOP_SMT1
        L1=SMT1_Measure; 
        Timer2_OFF();
        L2=L1<<1;           //  500Khz tick=2S => multiplie par 2   ,  31,25KHz L1>>5 par 32
        L2=L2/1000;
        sprintf(txt," Mesure Duree Affichage LCD repos \r\n via Timer2 %5d *100mS \r\n via SMT1 : Nb Tics %lu ,L2=%lu mS\r\n",Cpt2,L1,L2);
        Print(txt); 
        CRLF1();
    #endif
        
        
   
#ifdef Test_ZONE       
  // -----ligne 2570 --------  TEST ZONE  ----------------------------- 
  uint16_t Pselect;
  for (Pselect=0;Pselect<8;Pselect++)
  {   sprintf(CRam1," Psel=%d \r\n",Pselect)     ;
      Print(CRam1);
      for (i=24;i<31;i++)
      {   
          LCD_Chr_At(1,1+i-24, Tables_Programmations_Horaires[Pselect][i]);      
          sprintf(CRam1," i=%d   %c\r\n",i,Tables_Programmations_Horaires[Pselect][i] );     
           Print(CRam1);
      }
  }
  CRLF1();
  sprintf(CRam1," Pselect=%d  et i=%d \r\n",Pselect,i)     ;
  Print(CRam1);      
  do
  {
  }
  while(1);
  //-----------------------------------------------------
#endif      
        
        
        
        
        

    // 19-02-2024
    // RC5 est dsormais une entre uniquement ddie  SW6, sans aucun lien avec Alarme (plus de double dfinition)
                 
    // pour mesure duree boucle principale 
    CPrint(" Re-Init Cpt2 Timer2 100mS pour mesure duree de boucle\r\n");
    Init_Timer2();          // tick=100mS  * Cpt2 
    Cpt2=0;
    
    #ifdef With_STM1    
        CPrint(" Arme SMT1 compteur 24bits\r\n");
        START_SMT1   
    #endif  

    Menu=0; MPas=0;SPas=0;
   // Controle_Chaudiere=ON;
    
    //==========================================================================
    //                        Boucle Principale 
    //==========================================================================       
    
    do
    {
        if(PIR3bits.TMR0IF==1) CPrint("\r\n 10 sec ecoulee ..\r\n");
        Init_Timer0_10S(0); // en mode ppoling
        // si en mode Interrupt on doit tester 
        // if(Drapeaux.Tmr0_Elapsed==1) CPrint("\r\n 10 sec ecoule ..\r\n");
      
        if (Bavard==0)
        {
            sprintf(txt," %05d ",Nb_Boucles);
            Print(txt);
            CRLF1();
        }
       
        // if(HHMN_force==0)  Print_Date_Complete();   
        if (HHMN_force==0) Display_Date_Time(Bavard==1);    // lecture RTC et eventuel affichage
        // if(HHMN_force==0) Display_Date_Time(Bavard);     // lecture RTC et eventuel affichage
        // si HHMN_force=1   vakleur Hour et Minu provient d'une commande clacier terminal
           
        // Saisie des 3 measures DS18B20 et applique la correction (issue de l'Autocalibration)
        INT_mes= getTemperature1()+Txcor[0];  
        EXT_mes= getTemperature2()+Txcor[1];
        EAU_mes= getTemperature3()+Txcor[2];
       
        if (Bavard==3)
        {
            sprintf(txt," Mode %s consigne= %3.1f",Aff_CHX_mod[ Choix_Conf_Eco],(Choix_Conf_Eco==1)?CFT_csg:ECO_csg);
            Print(txt);CRLF1();
            sprintf(txt," INT_mes = %5.2f%c C", INT_mes,176);
            Print(txt);CRLF1();
            sprintf(txt," EXT_mes = %5.2f %cC",EXT_mes,176);
            Print(txt);CRLF1();
            sprintf(txt," EAU_mes = %5.2f %cC\r\n",EAU_mes,176);
            Print(txt);CRLF1();
        }
  
        //=================Traitement suite appui sur un BP ====================
        // Entre dans un MENU LCD
        // ou Action directe 
        txt=&TEXTE[0]; 
        if (Etats_BP>0)
        {    
            sprintf(txt," Duree = %d mS , ",Duree_Appui);
            Print(txt);
            sprintf(txt," BP=0X%02X,   Menu=%3d ",Etats_BP,Menu);         
            Print(txt);
            for (i=0;i<6;i++)
            {  
                cx= 1 << i;
                if (Etats_BP==cx  )
                {
                    CPrint(Switches[i]);
                }
            }
            // Etats_IOCBF=0;
            Etats_BP=0;
            Drapeaux.Key_ON=0; 
            CRLF1();
        }
    
        //========================= Action SW0 court ===========================
        // ----------------  MENUS via acces SW0  < 1 sec ----------------------
        while (Menu==10)    
        {   
            sprintf(CRam1," Menu= %3d MPas= %3d \r\n",Menu,MPas);
            Print(CRam1);    
            switch (MPas) 
                {   
                    case 0 : break;
                    case 1 : MENU10_1_CONSIGNES();  break; 
                    case 2 : MENU10_2_COMPENSATION(); break;  
                    case 3 : MENU10_3_LIMITES_CHD(); break;   
                    case 4 : MENU10_4_HYSTERESIS(); break;
                    default: MPas=0; break;
                }   //switch MPas    
        }
    
        //----------------------- MENUS DIRECTS --------------------------------
        if (Controle_Chaudiere==ON) //  si non en ARRET TOTAL
        {   
            //====================== Action SW1 court ==========================
       //     if ((Menu==1) && (Choix_Hors_Gel==0) )    // Bascule MODE Forc / Normal (si non en Mode Hors Gel)
            if (Menu==1)  // by HT
            {   
                // pas d'action necessaire sur autre BP
                PIE1bits.INT0IE=0; 
                PIR1bits.INT0IF=0;
                Etats_BP=0;
                CPrint(" SW1 Toogle Change Mode\r\n"); 
                Print(CRam1);
                Forcage_Mode = Forcage_Mode ^ 0x0001;   // togle bit
                Forcage_Consigne=0;                     // Reset Forcage Consigne
                if (Forcage_Mode==1)        // MODE FORCE
                { 
                    if (Mode_Progr==CFT)Mode_En_Cours=ECO; 
                    if (Mode_Progr==ECO)Mode_En_Cours=CFT;
                    LCD_Write_CText_At(1,1 ," Forcage Mode       ");
                    CPrint(" Forcage Mode = ");
                }
                else                        // MODE NORMAL
                {
                    LCD_Write_CText_At(1,1 ," Retour Mode Normal ");
                    CPrint(" Retour Mode Normal ,Forcage Mode = "); 
                } 
                PrintChar('0'+Forcage_Mode);CRLF1();
                __delay_xSec(2);
                Terminaison_Menu_Direct();  // => Menu=0;
            }   // Fin Menu1
  
            //====================== Action SW2 court ==========================
            if ( (Menu==2) && (Choix_Hors_Gel==0) )    // Increment CONSIGNE Force (si non en Mode Hors Gel)+
            {  
                // pas d'action necessaire sur autre BP
                PIE1bits.INT0IE=0;
                PIR1bits.INT0IF=0;
                Etats_BP=0;
                if (Mode_En_Cours==1)       // Mode CONFORT => maxi=22.0
                {    
                    U1TXB='+';   
                    if ( CSG_En_Cours < Max_CFT_csg)  CSG_En_Cours= CSG_En_Cours + 0.5;
                    sprintf(CRam1,"SW2 Incr consigne forcee CFT : %3.2f\r\n",CSG_En_Cours); 
                    F0=CSG_En_Cours-CFT_csg;
                    if (F0>0.4) LCD_char15=fleche_H;
                    if (F0<0.4) LCD_char15=fleche_B;
                    Forcage_Consigne = 1;                    
                }
                if (Mode_En_Cours==0)       // Mode ECO => maxi=18.0 
                {     U1TXB='+';   
                    if ( CSG_En_Cours < Max_ECO_csg)   CSG_En_Cours= CSG_En_Cours + 0.5;
                    sprintf(CRam1,"SW2 Incr consigne forcee  ECO : %3.2f\r\n", CSG_En_Cours);  
                    F0=CSG_En_Cours - ECO_csg;
                    if (F0>0.4) LCD_char15=fleche_H;
                    if (F0<0.4) LCD_char15=fleche_B;
                    Forcage_Consigne = 1;
                }
                if (CSG_En_Cours==CFT_csg)  // remplace cas F0==0
                {
                    Forcage_Consigne = 0; 
                    LCD_char15=' ';                   
                }
                if (CSG_En_Cours==ECO_csg)  // remplace cas F0==0
                {
                    Forcage_Consigne = 0; 
                    LCD_char15=' ';                   
                }                
            /*
                if(F0== 0.0)
                {
                    LCD_char15=' ' ;
                    Forcage_Consigne=0;
                }  
                if(F0>0.1)
                {
                    Forcage_Consigne=1;
                    LCD_char15=fleche_H ;   // 4 pour choix fleche HAUT
                }
                if(F0<0.1) 
                {
                    Forcage_Consigne=1;  
                    LCD_char15=fleche_B ;   // 5 pour choix fleche BAS
                } 
            */ 
                Print(CRam1);
                Terminaison_Menu_Direct();                
            }   // Fin Menu2 
            
            //====================== Action SW3 court ==========================
            if  ( (Menu==3) && (Choix_Hors_Gel==0) )    // Decrement CONSIGNE forcee (si non en Mode Hors Gel) 
            {  
                // pas d'action necessaire sur BP
                PIE1bits.INT0IE=0; 
                PIR1bits.INT0IF=0;
                Etats_BP=0;
                // sprintf(CRam1, " Etats_BP= %02X\t",Etats_BP);
                // Print(CRam1);
        
                if (Mode_En_Cours==1)       // Mode CONFORT => mini=16.0 // was Choix_Conf_Eco
                {   
                    U1TXB='-';  
                    if (CSG_En_Cours > Min_CFT_csg)  CSG_En_Cours= CSG_En_Cours -0.500;
                    sprintf(CRam1,"SW3 Decr consigne forcee CFT : %3.1f\r\n",CSG_En_Cours);  
                    F0=CSG_En_Cours - CFT_csg;
                    if (F0<0.4) LCD_char15 = fleche_B;
                    if (F0>0.4) LCD_char15 = fleche_H;
                    Forcage_Consigne = 1;                    
                }
                if (Mode_En_Cours==0)       // Mode ECO => mini=12.0    // was Choix_Conf_Eco
                {     U1TXB='-';     
                    if (CSG_En_Cours > Min_ECO_csg)  CSG_En_Cours=CSG_En_Cours - 0.500;
                    sprintf(CRam1,"SW2 DEcr consigne forcee ECO : %3.1f\r\n",CSG_En_Cours);  
                    F0=CSG_En_Cours - ECO_csg;
                    if (F0<0.4) LCD_char15 = fleche_B;
                    if (F0>0.4) LCD_char15 = fleche_H;
                    Forcage_Consigne = 1;                    
                }                
                if (CSG_En_Cours==CFT_csg)  // remplace cas F0==0
                {
                    Forcage_Consigne = 0; 
                    LCD_char15=' ';                   
                }
                if (CSG_En_Cours==ECO_csg)  // remplace cas F0==0
                {
                    Forcage_Consigne = 0; 
                    LCD_char15=' ';                   
                }                 
            /*   
                if(F0==0.0)
                {
                    LCD_char15=' ' ;
                    Forcage_Consigne=0;
                }    
                if(F0>0.1)
                {
                    Forcage_Consigne=1;
                    LCD_char15=4 ;// pour choix fleche HAUT
                }     
                if(F0<0.1) 
                {
                    Forcage_Consigne=1;  
                    LCD_char15=5 ;// pour choix fleche BAS
                } 
            */ 
                Print(CRam1);
                Terminaison_Menu_Direct(); 
            }   // Fin Menu3
    
         
        //=========== MENU 4  ===== Action SW4 (long) ===========================    
        //------------Affectation ou modif programmation Horaire ---------------
        if (Menu==4)
        {   //rev 15/05/2024
            PIR1bits.INT0IF=0;
            PIE1bits.INT0IE=0; 
            Etats_BP=0;
            Dummy=1;
            Choix_SW4=0;
            LCD_Cmd(LCD_CLEAR);__delay_ms(100);
            sprintf(CRam1," MENU4 via SW4L    "); 
            Print(CRam1);
            LCD_Write_Text_At(1,1,CRam1);
            CRLF1();
            LCD_Write_CText_At(2,1,"> Affect Progr->Jour");
            LCD_Write_CText_At(3,1," Modif Progr.Horaire");
            LCD_Write_CText_At(4,1,"Choix=SW1,SW1L=Valid"); 
            IOCBF=0;
            Etats_BP=0;
            PIE1bits.INT0IE=1; 
            do
            {  
                if(Etats_BP==SW1 && Duree_Appui<1000) 
                {
                    // choix Affect
                    Dummy++;
                    if(Dummy>2) Dummy=1;
                    if(Dummy==1) sprintf(CRam1,"SW4a) Affectation Prg au jour\r\n"); 
                    if(Dummy==2) sprintf(CRam1,"SW4b) Modif. Program Horaire\r\n"); 
                    Print(CRam1);
                    Etats_BP=0;
                    Restart_Timeout();
                }	
                if(Dummy==1) 
                {
                    LCD_Chr_At(2,1,'>');
                    LCD_Chr_At(3,1,' ');
                }
                if(Dummy==2) 
                {
                    LCD_Chr_At(2,1,' ');
                    LCD_Chr_At(3,1,'>');
                } 
                __delay_ms(300);
                LCD_Chr_At(2,1,' ');
                LCD_Chr_At(3,1,' ');
                __delay_ms(300);   
                if(Etats_BP==SW1 && Duree_Appui>1000) 
                {  
                    sprintf(CRam1," choix valid.\r\n"); 
                    Choix_SW4=Dummy;
                    if(Choix_SW4==1)Erase_Line(3); else Erase_Line(2);
                    Print(CRam1);
                    LCD_Write_CText_At(4,1," Valider par SW4L    "); 
                    __delay_xSec(2);
                    Etats_BP=0;
                    Restart_Timeout();
                }
                if(Etats_BP==SW0 && Duree_Appui>1000) break;
            }
            while ( (Choix_SW4==0) && (PIR3bits.TMR0IF == 0) ) ;
            PIE1bits.INT0IE=0; 
            if(Choix_SW4==1) Affectation_Programme_au_Jour_Semaine();
            if(Choix_SW4==2) Modification_Programmation_Horaire();
            //sortie
            Menu=4;
            Terminaison_Menu_Direct();
        }   // Fin Menu4
    
        //======================== Action SW5 (long) ===========================
        //------------------------ MAJ MANUELLE RTC ----------------------------
        if (Menu==5)
        {      
            PIR1bits.INT0IF=0;
            PIE1bits.INT0IE=0; 
            IOCBF=0;
            Etats_BP=0;
            sprintf(CRam1," SW5 Menu=%2d MAJ horloge RTC (en mode spooling) \r\n",Menu);  
            Print(CRam1);
            MAJ_RTC_Manuelle();
            Terminaison_Menu_Direct();
        }   // Fin Menu5 
      
            
            
        //============== Menu 6    Action SW1 + SW2 (long) ========================    
        //-------------------------- ARRET TOTAL -------------------------------
        if (Menu==6 ) 
        {     
            PIR1bits.INT0IF=0;
            PIE1bits.INT0IE=0; 
            Etats_BP=0;
            CPrint("SW1+SW2  Controle Chaudiere=");
            if(Controle_Chaudiere==1)
            {
                Controle_Chaudiere=0; 
                LCD_Write_CText_At(3,6,"  ARRET TOTAL  ");
                Bruleur=0;
                LCD_Write_CText_At(4,6,"START=SW1L+SW2L");
            }
            else
            {
                Controle_Chaudiere=1; 
                LCD_Write_CText_At(3,6," RETOUR NORMAL");
            }
            PrintChar(Controle_Chaudiere+48); CRLF1();
             __delay_xSec(3);
            CPrint(" save to Eeeprom @ Org_Sauve_Param_Travail + 71\r\n"); 
            DATAEE_WriteByte ( Org_Sauve_Param_Travail + 71 ,Controle_Chaudiere);
            Terminaison_Menu_Direct();
        }   //Fin Menu6    
            
            
           //============Menu 7   Action SW1 + SW3 (long) ====================== 
            //------------------- bascule Hors Gel / Normal --------------------
            if (Menu==7)   
            {     
                PIR1bits.INT0IF=0;
                PIE1bits.INT0IE=0; 
                Etats_BP=0;
                 CPrint("SW1+SW3   bascule Hors Gel ou Normal)\r\n"); 
                if(Choix_Hors_Gel==0) 
                {
                   Choix_Hors_Gel=1;
                    Progr_En_Cours=10 ; //W
                    CSG_En_Cours=HGL_csg;
                    sprintf(CRam1,"Int %3.1f   Csg=%3.1f ",INT_mes,CSG_En_Cours);   
                    *(CRam1+6)=7;
                    *(CRam1+17)=7;
                    LCD_Write_Text_At(2,1,CRam1);   
                    sprintf(CRam1,"%c%c:%c%c    HORS GEL    ",time[0],time[1],time[3],time[4]);  
                    LCD_Write_Text_At(3,1,CRam1); 
                    sprintf(CRam1,"%1c %c%c                ",Progr_Name[Progr_En_Cours],*(All_Jour_Semaine+jS*2),*(All_Jour_Semaine+jS*2 +1 ) );
                    LCD_Write_Text_At(4,1,CRam1);  // Caractre W ? 
                              
                }
                else
                {
                    Choix_Hors_Gel=0;
                    strConstRamCpy(CRam1," RETOUR A  ");
                    LCD_Write_Text_At(2,9,CRam1);
                    strConstRamCpy(CRam1,"  NORMAL   ");
                    LCD_Write_Text_At(3,9,CRam1);
                    LCD_Chr_At(4,1,' ');  // cad : Caractre du Programme affect au Jour en curs ?
                } 
                sprintf(CRam1," Mode  %s ", (Choix_Hors_Gel==0)?"Normal":"Hors_Gel");
                Print(CRam1);
          
                CPrint("Save to eeprom CSG_En_Cours @44 et  Choix_Hors_Gel @70\r\n");
                Sauve_Float_To_Eeprom(Org_Sauve_Param_Travail+44,CSG_En_Cours); // 15-09-2024
	            DATAEE_WriteByte(Org_Sauve_Param_Travail+70, Choix_Hors_Gel);// 15-09-2024    was Org_Sauve_Progr_Travail
	            __delay_xSec(2);
                Terminaison_Menu_Direct();
            }   // Fin Menu7   
        }   // Fin si Controle Chaudiere=ON
        
     
            
        //===================== Action SW2 + SW3 (long) ========================
        // ------------------------- RAZ alarmes--------------------------------
#ifdef Paul_Board
        // PF Si entre Al1=0 (RC1) et Al2=0 (RC2)  LOW => On peut Dbloquer par Menu8
        if ( (Menu==8) && (Alarm_Inp1==0) && (Alarm_Inp2==0) )
        {
#else
       // HT Si entre Al1=1 (RC1) et Al2=1 (RC2)  HIGH => On peut Dbloquer par Menu8
        if ( (Menu==8) && (Alarm_Inp1==1) && (Alarm_Inp2==1) )
        {
#endif
               
            PIR1bits.INT0IF=0;
            PIE1bits.INT0IE=0; 
            Etats_BP=0;
            CPrint("Reset Alarmes \r\n");
            LCD_Write_CText_At(1,1,"   Reset Alarme    ");
            sprintf(CRam1,"AL1=%c AL2=%c disparue", (Alarm_Inp1>>1)+48,(Alarm_Inp2>>2)+48);
            Print(CRam1);CRLF1();
            LCD_Write_Text_At(2,1,CRam1);
            Erase_Line(3);
            Erase_Line(4);
            __delay_xSec(3);
           Etat_Alarme=0; 
           Alarm_Out=1;  //stop alarme
            Controle_Chaudiere=ON;
            CPrint(" save to eeprom @68,69,71\r\n");
        //    DATAEE_WriteByte ( Org_Sauve_Progr_Travail+ 68 ,Alarmes);
            DATAEE_WriteByte ( Org_Sauve_Param_Travail+ 68 ,Alarmes);
            DATAEE_WriteByte ( Org_Sauve_Param_Travail+ 69 ,Etat_Alarme);
            DATAEE_WriteByte ( Org_Sauve_Param_Travail+ 71 ,Controle_Chaudiere);
            Terminaison_Menu_Direct();
        }   // Fin Menu8

        cx=PORTB;
        
      //  Affiche_LCD_Repos(); 
  
        //--- dialogue bi-directionnel OPERATEUR <-> terminal PC ou bluetooth --
        #include "Dialogue_Operateur_PC_via_UART_2024-0904.inc"
        // ---------------------------------------------------------------------
        #ifdef With_STM1   
            STOP_SMT1
            L1=SMT1_Measure; 
            L2=L1<<1;       //  500Khz tick=2S => multiplie par 2   ,  31,25KHz L1>>5 par 32
            START_SMT1      // pour la prochaine boucle    
        #endif
        Duree_Boucle= Cpt2; // tick de comptage timer2 =100  
        if (Bavard==4) 
        { 
            sprintf(CRam1," %02dH%02dM%02ds  Mode=%s  Boucle en => %d x 100mS",
            Hour,Minut,Sec, Aff_CHX_mod[Mode_En_Cours], Duree_Boucle);
            Print(CRam1);
            CRLF1();
            #ifdef With_STM1  
                sprintf(CRam1,"   SMT1 =>%lu uS\r\n",L2);
                Print(CRam1);
                // avec BAV=4
                // (20:45:32.123)  HH =20 MM=45 Mode_Conf_Eco=Ec second=4  Timer2=> 30 x 100mS  SMT1 =>3104300 uS (avec lcd write char)
                CRLF1();
            #endif  
        }    
        Init_Timer2();
    
        //======================== REGULATION ==================================
        Calcul_Consigne_Eau_Chaudiere();            // version Paul
     
        
        if ( (INT_mes < INT_cbl) && (EAU_mes < EAU_cbl) && (Controle_Chaudiere==ON) )
        {   // Il faut Chauffer...
            if (Bruleur==0) __delay_xSec(5);// Latence...5s
            Bruleur=1;
        }
        else// Pas de Cjhauffe
        {    
            if (Bruleur==1) __delay_xSec(5);// Latence...5s                
            Bruleur=0; 
        } 

        //------------------------- Affichage YAT ------------------------------
        if (Bavard ==14)
        { 
            sprintf(CRam1," Prog Select= %2d Progr en cours=%2d Prog Name %c \r\n",Progr_Select,Progr_En_Cours,Progr_Name[Progr_En_Cours]);
            Print(CRam1);
            sprintf(CRam1," Mode en cours= %2d -> %s\r\n",Mode_En_Cours, Aff_CHX_mod[Mode_En_Cours]);
            Print(CRam1);
            sprintf(CRam1," Consigne= %3.2f\r\n",CSG_En_Cours );
            Print(CRam1);
            sprintf(CRam1," INT_mes= %3.1f\r\n", INT_mes);
            Print(CRam1);
            sprintf(CRam1," Pente= %3.2f\r\n", Pente );    
            Print(CRam1);
            sprintf(CRam1," Offset= %3.2f\r\n", Offset);  
            Print(CRam1);
            sprintf(CRam1," EAU_cbl= %3d\r\n", EAU_cbl);
            Print(CRam1);
            sprintf(CRam1," Etat alarmes 0X%02x \r\n",PORTC & 0x06);
            Print(CRam1);
            // A dfinir...
            if (Etat_Bruleur==0) sprintf(CRam1," Bruleur= OFF (#)");                        
            if (Etat_Bruleur==1) sprintf(CRam1," Bruleur= ON ($)"); 
            Print(CRam1);
            CRLF1();
        }
        
        //=================== GESTION ALARMES CHAUDIERE =======================
        // Si entre Al1=2 (RC1) ou Al2=4 (RC2)  => Bloqu en Alarme + dblocage impossible par Menu8
        if(Bavard==12)
        {
            sprintf(CRam1," ETAT entree PORTC =0x%02X  AL1=%02x  AL2=%02x \r\n",PORTC,Alarm_Inp1,Alarm_Inp2);
            Print(CRam1);
        }      
        #ifdef Paul_Board
        if (  (Alarm_Inp1>0) || (Alarm_Inp2>0) || (Etat_Alarme>0) ) //  carte Paul
        {
        CPrint(" Carte Paul : ");
        #else   
        // Si entre Al1=0 (RC1) ou Al2=0 (RC2)  => Bloqu en Alarme + dblocage impossible par Menu8
        if (  (Alarm_Inp1==0) || ( Alarm_Inp2==0) || (Etat_Alarme>0)  ) // carte Henri
        {
        CPrint(" Carte Henri : ");
        #endif    
 
         sprintf( CRam1," AL1=%1d  AL2=%1d      ",PORTC & 0x02,PORTC & 0x04 );
         Print(CRam1);CRLF1();
         LCD_Write_CText_At(2,1,CRam1);
         Alarmes= PORTC & 0x06;   // etat entrees alarmes regroupe
         if (Etat_Alarme==0)
         {     Etat_Alarme=1;
               DATAEE_WriteByte (Org_Sauve_Param_Travail + 68 ,Alarmes);
               DATAEE_WriteByte ( Org_Sauve_Param_Travail+ 69 ,Etat_Alarme);  // corrig 15/09
               CPrint(" save Etat inp Alarmes @68 et Etat Out Alarme @69 to Eeprom\r\n");
         
         } 
        }
           if (Etat_Alarme>0) 
           {               
            Alarm_Out=0; // Alarme ON
            Controle_Chaudiere=OFF;
            Requete_Bruleur=0;
            Bruleur=0;            //12345678901234567890
            LCD_Write_CText_At(1,1," !ALARME CHAUDIERE! ");      
            LCD_Write_CText_At(3,1,"--------------------");
            LCD_Write_CText_At(4,1,"REPARATION DEMANDEE!");  
            #ifdef Paul_Board
           if (Alarm_Inp1>0) LCD_Write_CText_At(2,1,"VEILLEUSE CHAUDIERE!");
           if (Alarm_Inp2>0) LCD_Write_CText_At(2,1,"PRESS EAU CHAUDIERE!"); 
           if ( (Alarm_Inp1==0) &&(Alarm_Inp2==0))  LCD_Write_CText_At(3,1,"SW2+SW3 ACQUIT ALARM");
            #else
            if (Alarm_Inp1==0) LCD_Write_CText_At(2,1,"VEILLEUSE CHAUDIERE!":
            if (Alarm_Inp2==0) LCD_Write_CText_At(2,1,"PRESS EAU CHAUDIERE!"); 
            if ( (Alarm_Inp1>0) &&(Alarm_Inp2>0))  LCD_Write_CText_At(3,1,"SW2+SW3 ACQUIT ALARM");
            #endif
            CPrint("!ALARME CHAUDIERE! r\n");
            __delay_xSec(2);
           }
           else
               
           Affiche_LCD_Repos();    
                
     Nb_Boucles ++;      
    }   
    while (1); 
  
  
}
